<?php

/**
 * Description of Ereignis
 * Diese Klasse gibt die Ereignisse des IPS-Systems in Html aus
 * @author Dirk Kruck
 */
class Ereignis {
	private $ListeKategorien = array();
	private $ListeInstanzen = array();
	private $ListeVariablen = array();
	private $ListeEreignisse = array();
	private $ListeScripte = array();
	private $Id = null;
	private $Name = null;
	private $Parent = null;
	private $Icon = null;
	private $Info = null;
	private $Position = null;
	private $Hidden = null;
	private $HtmlSeiten = "";
	private $ArrayKategorienObject = null;
	private $ArrayInstanzenObject = null;
	private $ArrayVariablenObject = null;
	private $ArrayEreignisseObject = null;
	private $ArrayScripteObject = null;

	public function __construct(){
		$this->ArrayKategorienObject = new ArrayObject($this->ListeKategorien);
		$this->ArrayInstanzenObject = new ArrayObject($this->ListeInstanzen);
		$this->ArrayVariablenObject = new ArrayObject($this->ListeVariablen);
		$this->ArrayEreignisseObject = new ArrayObject($this->ListeEreignisse);
		$this->ArrayScripteObject = new ArrayObject($this->ListeScripte);
	}
	// Gib den Namen des Ereignis zurck
	public function getName() {
		return $this->Name;
	}
	// Setzt den Namen des Ereignis
	public function setName($Name) {
		$this->Name = $Name;
	}
	// Gib die Objektnummer des Ereignis zurck
	public function getId(){
		return $this->Id;
	}
	// Setzt die Objektnummer des Ereignis
	public function setId($Id) {
		$this->Id = $Id;
	}
	// Gib den Iconname des Ereignis zurck
	public function getIcon(){
		return $this->Icon;
	}
	// Setzt den Iconname des Ereignis
	public function setIcon($Icon) {
		$this->Icon = $Icon;
	}
	// Gib die Info des Ereignis zurck
	public function getInfo(){
		return $this->Info;
	}
	// Setzt die Info des Ereignis
	public function setInfo($Info) {
		$this->Info = $Info;
	}
	// Gib die Objektnummer des Parentobjekt des Ereignis zurck
	public function getParent(){
		return $this->Parent;
	}
	// Setzt die Objektnummer des Parentobjekt des Ereignis
	public function setParent($Parent) {
		$this->Parent = $Parent;
	}
	// Gib die Position(Reihenfolge) des Ereignis zurck
	public function getPosition(){
		return $this->Position;
	}
	// Setzt die Position(Reihenfolge) des Ereignis
	public function setPosition($Position) {
		$this->Position = $Position;
	}
	// Gib den Status der Sichtbarkeit des Ereignis zurck
	public function getHidden(){
		return $this->Hidden;
	}
	// Setzt den Status der Sichtbarkeit des Ereignis
	public function setHidden($Hidden) {
		$this->Hidden = $Hidden;
	}
	// Kategorieobjekt in Liste einfgen
	public function addKategorie($Kategorie)
	{
		$this->ArrayKategorienObject->append($Kategorie);
	}
	// Instanzobjekt in Liste einfgen
	public function addInstanz($Instanz)
	{
		$this->ArrayInstanzenObject->append($Instanz);
	}
	// Variableobjekt in Liste einfgen
	public function addVariable($Variable)
	{
		$this->ArrayVariablenObject->append($Variable);
	}
	// Ereignisobjekt in Liste einfgen
	public function addEreignis($Ereignis)
	{
		$this->ArrayEreignisseObject->append($Ereignis);
	}
	// Instanzobjekt in Liste einfgen
	public function addScript($Script)
	{
		$this->ArrayScripteObject->append($Script);
	}
	//Gib die Liste der Kategorien zurck
	public function getKategorieArray(){
		return $this->ArrayKategorienObject;
	}
	//Gib die Liste der Instanzen zurck
	public function getInstanzArray(){
		return $this->ArrayInstanzenObject;
	}
	//Gib die Liste der Variablen zurck
	public function getVariableArray(){
		return $this->ArrayVariablenObject;
	}
	//Gib die Liste der Ereignisse zurck
	public function getEreignisArray(){
		return $this->ArrayEreignisseObject;
	}
	//Gib die Liste der Scripte zurck
	public function getScriptArray(){
		return $this->ArrayScripteObject;
	}
	// Schreibt die Html-Zeile fr das Ereignis
	public function toEreignisHtml() {
		$textVar = $this->getName().$this->getID();
		$textVar = Utility::umlaute_ersetzen(utf8_encode($textVar));
		$this->HtmlSeiten.="<li><span>".$this->getName()."</span><span class='wert' id='".$textVar."'>"."</span></li>";
		$this->HtmlSeiten.="\n";
		return $this->HtmlSeiten;
	}
}
?>
