<?php

/**
 * Description of Instanz
 * Diese Klasse gibt die Instanzen des IPS-Systems in Html und Java-Script aus
 * @author Dirk Kruck
 */
class Instanz {
	private $ListeKategorien = array();
	private $ListeInstanzen = array();
	private $ListeVariablen = array();
	private $ListeEreignisse = array();
	private $ListeScripte = array();
	private $Id = null;
	private $Name = null;
	private $Parent = null;
	private $Icon = null;
	private $Info = null;
	private $Position = null;
	private $Hidden = null;
	private $ModuleID = null;
	private $ModuleName = null;
	private $ModuleType = null;
	private $ArrayKategorienObject = null;
	private $ArrayInstanzenObject = null;
	private $ArrayVariablenObject = null;
	private $ArrayEreignisseObject = null;
	private $ArrayScripteObject = null;
	private $HtmlSeiten = "";
	private $IpsGetFunktion = "";
	private $IpsSetFunktion = "";
	private $IpsSwitchFunktion = "";
	private $IpsSwitchAufruf = "";
	private $GraphAufruf = "";

	public function __construct(){
		$this->ArrayKategorienObject = new ArrayObject($this->ListeKategorien);
		$this->ArrayInstanzenObject = new ArrayObject($this->ListeInstanzen);
		$this->ArrayVariablenObject = new ArrayObject($this->ListeVariablen);
		$this->ArrayEreignisseObject = new ArrayObject($this->ListeEreignisse);
		$this->ArrayScripteObject = new ArrayObject($this->ListeScripte);
	}
	// Gibt den Namen der Instanz zurck
	public function getName() {
		return $this->Name;
	}
	// Setzt den Namen der Instanz
	public function setName($Name) {
		$this->Name = $Name;
	}
	// Gibt die Objektnummer der Instanz zurck
	public function getId(){
		return $this->Id;
	}
	// Setzt die Objektnummer der Instanz
	public function setId($Id) {
		$this->Id = $Id;
	}
	// Gibt den Iconname der Instanz zurck
	public function getIcon(){
		return $this->Icon;
	}
	// Setzt den Iconname der Instanz
	public function setIcon($Icon) {
		$this->Icon = $Icon;
	}
	// Gibt die Info der Instanz zurck
	public function getInfo(){
		return $this->Info;
	}
	// Setzt die Info der Instanz
	public function setInfo($Info) {
		$this->Info = $Info;
	}
	// Gibt die Objektnummer des Parentobjekt der Instanz zurck
	public function getParent(){
		return $this->Parent;
	}
	// Setzt die Objektnummer des Parentobjekt der Instanz
	public function setParent($Parent) {
		$this->Parent = $Parent;
	}
	// Gibt die Position(Reihenfolge) der Instanz zurck
	public function getPosition(){
		return $this->Position;
	}
	// Setzt die Position(Reihenfolge) der Instanz
	public function setPosition($Position) {
		$this->Position = $Position;
	}
	// Gibtt den Status der Sichtbarkeit der Instanz zurck
	public function getHidden(){
		return $this->Hidden;
	}
	// Setzt den Status der Sichtbarkeit der Instanz
	public function setHidden($Hidden) {
		$this->Hidden = $Hidden;
	}
	// Gibt die ModuleID (FS20,Homematic,usw.) der Instanz zurck
	public function getModuleID(){
		return $this->ModuleID;
	}
	// Setzt die ModuleID (FS20,Homematic,usw.) der Instanz
	public function setModuleID($ModuleID) {
		$this->ModuleID = $ModuleID;
	}
	// Gibt den ModuleNamen (FS20,Homematic,usw.) der Instanz zurck
	public function getModuleName(){
		return $this->ModuleName;
	}
	// Setzt den ModuleName (FS20,Homematic,usw.) der Instanz
	public function setModuleName($ModuleName) {
		$this->ModuleName = $ModuleName;
	}
	// Kategorieobjekt in Liste einfgen
	public function addKategorie($Kategorie)
	{
		$this->ArrayKategorienObject->append($Kategorie);
	}
	// Instanzobjekt in Liste einfgen
	public function addInstanz($Instanz)
	{
		$this->ArrayInstanzenObject->append($Instanz);
	}
	// Variableobjekt in Liste einfgen
	public function addVariable($Variable)
	{
		$this->ArrayVariablenObject->append($Variable);
	}
	// Ereignisobjekt in Liste einfgen
	public function addEreignis($Ereignis)
	{
		$this->ArrayEreignisseObject->append($Ereignis);
	}
	// Instanzobjekt in Liste einfgen
	public function addScript($Script)
	{
		$this->ArrayScripteObject->append($Script);
	}
	//Gibt die Liste der Kategorien zurck
	public function getKategorieArray(){
		return $this->ArrayKategorienObject;
	}
	//Gibt die Liste der Instanzen zurck
	public function getInstanzArray(){
		return $this->ArrayInstanzenObject;
	}
	//Gibt die Liste der Variablen zurck
	public function getVariableArray(){
		return $this->ArrayVariablenObject;
	}
	//Gibt die Liste der Ereignisse zurck
	public function getEreignisArray(){
		return $this->ArrayEreignisseObject;
	}
	//Gibt die Liste der Scripte zurck
	public function getScriptArray(){
		return $this->ArrayScripteObject;
	}
	// Schreibt die Html-Zeile fr die Instanz
	public function toInstanzHtml() {
		$this->HtmlSeiten.="<li data-role='list-divider' > <div align='center'>".$this->getName()."</div></li>";
		$this->HtmlSeiten.="\n";
		foreach ($this->getVariableArray() as $variable){
			$this->HtmlSeiten.=$variable->toVariableHtml();
		}
		return $this->HtmlSeiten;
	}
	// Schreibt den Java-Script fr die Variablen der Instanz
	public function toIpsGetFunktion() {
		foreach ($this->getVariableArray() as $variable){
			$this->IpsGetFunktion.=$variable->toIpsGetFunktion();
		}
		return $this->IpsGetFunktion;
	}
	// Schreibt den Java-Script(Setter Methoden z.B. SetBoolean,SetInteger,usw.) fr die Variablen der Instanz
	public function toIpsSetFunktion() {
		foreach ($this->getVariableArray() as $variable){
			$this->IpsSetFunktion.=$variable->toIpsSetFunktion();
		}
		return $this->IpsSetFunktion;
	}
	// Schreibt den Java-Script(fr Schalter FS20,Homematic,usw.) fr die Variablen der Instanz
	public function toIpsSwitchFunktion() {
		foreach ($this->getVariableArray() as $variable){
			$textVar = $this->getName().$this->getID();
			$textVar = Utility::umlaute_ersetzen(utf8_encode($textVar));
			if($this->getModuleName() == 'FS20'){
				$this->IpsSwitchFunktion.="(function($) {";
				$this->IpsSwitchFunktion.="\n";
				$this->IpsSwitchFunktion.="$.fn.ips".$textVar."= function(homesite) {";
				$this->IpsSwitchFunktion.="\n";
	 		$this->IpsSwitchFunktion.=$variable->toIpsSwitchFunktion($this->getModuleName());
	 		$this->IpsSwitchFunktion.="}";
	 		$this->IpsSwitchFunktion.="\n";
	 		$this->IpsSwitchFunktion.="})(jQuery);";
	 		$this->IpsSwitchFunktion.="\n";
			}elseif($this->getModuleName() == 'HomeMatic Device'){
				$this->IpsSwitchFunktion.="(function($) {";
				$this->IpsSwitchFunktion.="\n";
				$this->IpsSwitchFunktion.="$.fn.ips".$textVar."= function(homesite) {";
				$this->IpsSwitchFunktion.="\n";
	 		$this->IpsSwitchFunktion.=$variable->toIpsSwitchFunktion($this->getModuleName());
	 		$this->IpsSwitchFunktion.="}";
	 		$this->IpsSwitchFunktion.="\n";
	 		$this->IpsSwitchFunktion.="})(jQuery);";
	 		$this->IpsSwitchFunktion.="\n";
			}
		}
		return $this->IpsSwitchFunktion;
	}
	// Schreibt den Java-Script(fr virtuelle Schalter z.B. Alarmanlage Ein-Aus, usw.) fr die Variablen der Instanz
	public function toIpsSwitchAufruf() {
		foreach ($this->getVariableArray() as $variable){
			$textVar = $this->getName().$this->getID();
			$textVar = Utility::umlaute_ersetzen(utf8_encode($textVar));
			$this->IpsSwitchAufruf.= $variable->toIpsSwitchAufruf($this->getModuleName(),$textVar);
		}
		return $this->IpsSwitchAufruf;
	}
	// Schreibt den Java-Script Aufruf des Graphen
	public function toGraphAufruf() {
		foreach ($this->getVariableArray() as $variable){
			$textVar = $this->getName().$this->getID();
			$textVar = Utility::umlaute_ersetzen(utf8_encode($textVar));
			$this->GraphAufruf.= $variable->toGraphAufruf($this->getName());
		}
		return $this->GraphAufruf;
	}
}
?>