﻿<?php

/**
 * Description of Kategorie
 * Diese Klasse gibt die Kategorien des IPS-Systems in Html und Java-Script aus
 * @author Dirk Kruck
 */
include'Utility.php';

class Kategorie {
	private $ListeKategorien = array();
	private $ListeInstanzen = array();
	private $ListeVariablen = array();
	private $ListeEreignisse = array();
	private $ListeScripte = array();
	private $Id = null;
	private $Name = null;
	private $Parent = null;
	private $Icon = null;
	private $Info = null;
	private $Position = null;
	private $Hidden = null;
	private $ArrayKategorienObject = null;
	private $ArrayInstanzenObject = null;
	private $ArrayVariablenObject = null;
	private $ArrayEreignisseObject = null;
	private $ArrayScripteObject = null;
	private $HtmlSeiten = "";
	private $JavaScript = "";
	private $IpsGetScript = "";
	private $IpsSetScript = "";
	private $IpsSwitchScript = "";
	private $IpsScriptAufruf = "";
	private $GraphAufruf = "";
	private $Utility = null;
	private $SwitchBooleanScript = "";
	private $IpsSwitchBooleanScript = "";
	private $HtmlScriptStartenScript = "";
	private $IpsScriptStartenScript = "";
	private $SliderAufrufScript ="";

	public function __construct(){
		$Utility = new Utility();
		$this->ArrayKategorienObject = new ArrayObject($this->ListeKategorien);
		$this->ArrayInstanzenObject = new ArrayObject($this->ListeInstanzen);
		$this->ArrayVariablenObject = new ArrayObject($this->ListeVariablen);
		$this->ArrayEreignisseObject = new ArrayObject($this->ListeEreignisse);
		$this->ArrayScripteObject = new ArrayObject($this->ListeScripte);
	}
	// Gib den Namen der Kategorie zurück
	public function getName() {
		return $this->Name;
	}
	// Setzt den Namen der Kategorie
	public function setName($Name) {
		$this->Name = $Name;
	}
	// Gib die Objektnummer der Kategorie zurück
	public function getId(){
		return $this->Id;
	}
	// Setzt die Objektnummer der Kategorie
	public function setId($Id) {
		$this->Id = $Id;
	}
	// Gib den Iconname der Kategorie zurück
	public function getIcon(){
		return $this->Icon;
	}
	// Setzt den Iconname der Kategorie
	public function setIcon($Icon) {
		$this->Icon = $Icon;
	}
	// Gib die Info der Kategorie zurück
	public function getInfo(){
		return $this->Info;
	}
	// Setzt die Info der Kategorie
	public function setInfo($Info) {
		$this->Info = $Info;
	}
	// Gib die Objektnummer des Parentobjekt der Kategorie zurück
	public function getParent(){
		return $this->Parent;
	}
	// Setzt die Objektnummer des Parentobjekt der Kategorie
	public function setParent($Parent) {
		$this->Parent = $Parent;
	}
	// Gib die Position(Reihenfolge) der Kategorie zurück
	public function getPosition(){
		return $this->Position;
	}
	// Setzt die Position(Reihenfolge) der Kategorie
	public function setPosition($Position) {
		$this->Position = $Position;
	}
	// Gib den Status der Sichtbarkeit der Kategorie zurück
	public function getHidden(){
		return $this->Hidden;
	}
	// Setzt den Status der Sichtbarkeit der Kategorie
	public function setHidden($Hidden) {
		$this->Hidden = $Hidden;
	}
	// Kategorieobjekt in Liste einfügen
	public function addKategorie($Kategorie)
	{
		$this->ArrayKategorienObject->append($Kategorie);
	}
	// Instanzobjekt in Liste einfügen
	public function addInstanz($Instanz)
	{
		$this->ArrayInstanzenObject->append($Instanz);
	}
	// Variableobjekt in Liste einfügen
	public function addVariable($Variable)
	{
		$this->ArrayVariablenObject->append($Variable);
	}
	// Ereignisobjekt in Liste einfügen
	public function addEreignis($Ereignis)
	{
		$this->ArrayEreignisseObject->append($Ereignis);
	}
	// Instanzobjekt in Liste einfügen
	public function addScript($Script)
	{
		$this->ArrayScripteObject->append($Script);
	}
	//Gib die Liste der Kategorien zurück
	public function getKategorieArray(){
		return $this->ArrayKategorienObject;
	}
	//Gib die Liste der Instanzen zurück
	public function getInstanzArray(){
		return $this->ArrayInstanzenObject;
	}
	//Gib die Liste der Variablen zurück
	public function getVariableArray(){
		return $this->ArrayVariablenObject;
	}
	//Gib die Liste der Ereignisse zurück
	public function getEreignisArray(){
		return $this->ArrayEreignisseObject;
	}
	//Gib die Liste der Scripte zurück
	public function getScriptArray(){
		return $this->ArrayScripteObject;
	}
	// Schreibt alle Objekte die unter der Kategorie liegen in der Html-Datei
	public function toKategorieHtml() {
		foreach ($this->ArrayKategorienObject as $object ){
			$textVar = $object->getName().$object->getID();
			$textVar = Utility::umlaute_ersetzen(utf8_encode($textVar));
			$this->HtmlSeiten.="<li><a href='#".$textVar."'"." data-transition='slide'>".$object->getName()."</a></li>";
			$this->HtmlSeiten.="\n";
		}
		foreach ($this->ArrayVariablenObject as $variable ){
			$this->HtmlSeiten.=$variable->toVariableHtml();
		}
		foreach ($this->ArrayScripteObject as $script ){
			$this->HtmlSeiten.=$script->toScriptHtml();
		}
		foreach ($this->ArrayEreignisseObject as $ereignis ){
			$this->HtmlSeiten.=$ereignis->toEreignisHtml();
		}
		foreach ($this->ArrayInstanzenObject as $instanz ){
			$this->HtmlSeiten.=$instanz->toInstanzHtml();
			foreach ($instanz->getInstanzArray() as $instanzsub){
				$this->HtmlSeiten.=$instanzsub->toInstanzHtml();
			}
			if(count($instanz->getInstanzArray())>0){
				foreach ($instanzsub->getScriptArray() as $script){
					$this->HtmlSeiten.=$script->toScriptHtml();
				}
			}
		}
		return $this->HtmlSeiten;
	}
	// Schreibt den Java-Script für alle Variablen und Instanzen die unter der Katergorie liegen
	public function toIpsGetFunktion() {
		foreach ($this->ArrayVariablenObject as $variable ){
			$this->IpsGetScript.=$variable->toIpsGetFunktion();
		}
		foreach ($this->ArrayInstanzenObject as $instanz ){
			$this->IpsGetScript.=$instanz->toIpsGetFunktion();
			foreach ($instanz->getInstanzArray() as $instanzsub){
				$this->IpsGetScript.=$instanzsub->toIpsGetFunktion();
			}
		}
		return $this->IpsGetScript;
	}
	// Schreibt den Java-Script für alle Variablen (Setter Methoden z.B. SetBoolean,SetInteger,usw.) die unter der Katergorie liegen
	public function toIpsSetFunktion() {
		foreach ($this->ArrayVariablenObject as $variable ){
			$this->IpsSetScript.=$variable->toIpsSetFunktion();
		}
		return $this->IpsSetScript;

	}
	// Schreibt den Java-Script für alle Variablen die ein Slider sind(z.B. Heizungseinstellung Temperatur)  die unter der Katergorie liegen
	public function toSliderAufruf(){
		foreach ($this->ArrayVariablenObject as $variable ){
			$this->SliderAufrufScript.=$variable->toSliderAufruf();
		}
		return $this->SliderAufrufScript;
	}
	// Schreibt den Java-Script für alle Instanzen und Subinstanzen  die ein Schalter sind(z.B. FS20 Switch)  die unter der Katergorie liegen
	public function toIpsSwitchAufruf() {
		foreach ($this->ArrayInstanzenObject as $instanz ){
			$this->IpsScriptAufruf.=$instanz->toIpsSwitchAufruf();
			foreach ($instanz->getInstanzArray() as $instanzsub){
				$this->IpsScriptAufruf.=$instanzsub->toIpsSwitchAufruf();
			}
		}
		return $this->IpsScriptAufruf;
	}
	// Schreibt den Java-Script für alle Instanzen die als Graph gekennzeichnet sind(z.B. Temperatur oder Position )  die unter der Katergorie liegen
	public function toGraphAufruf() {
		foreach ($this->ArrayInstanzenObject as $instanz ){
			$this->GraphAufruf.=$instanz->toGraphAufruf();
			foreach ($instanz->getInstanzArray() as $instanzsub){
				$this->GraphAufruf.=$instanzsub->toGraphAufruf();
			}
		}
		return $this->GraphAufruf;
	}
	// Schreibt den Java-Script für alle Variablen die den Status eines Schalters zeigen(z.B. Schalter hat den Zustand Ein)  die unter der Katergorie liegen
	public function toSwitchBooleanFunktion(){
		foreach ($this->ArrayVariablenObject as $variable ){
			$this->SwitchBooleanScript.=$variable->toSwitchBooleanFunktion();
		}
		return $this->SwitchBooleanScript;
	}
	// Schreibt den Html-Script für alle Scripte die aufgerufen werden die unter der Katergorie liegen (Anzeige des Scripts mit Button zum Script starten)
	public function toHtmlScriptStarten(){
		foreach ($this->ArrayScripteObject as $scripte ){
			$this->HtmlScriptStartenScript.=$scripte->toHtmlScriptStarten();
		}
		return $this->HtmlScriptStartenScript;
	}
	// Schreibt den Java-Script für alle Scripte die unter der Katergorie liegen
	public function toIpsScriptStarten(){
		foreach ($this->ArrayScripteObject as $scripte ){
			$this->IpsScriptStartenScript.=$scripte->toIpsScriptStarten();
		}
		return $this->IpsScriptStartenScript;
	}
	// Schreibt den Java-Script für alle Variablen die virtuelle Schalter sind(z.B. Alarmanlage An-Aus)  die unter der Katergorie liegen
	public function toIpsSwitchBoolean(){
		foreach ($this->ArrayVariablenObject as $variable ){
			$this->IpsSwitchBooleanScript.=$variable->toIpsSwitchBoolean();
		}
		return $this->IpsSwitchBooleanScript;
	}

	public function toIpsSwitchFunktion() {
		foreach ($this->ArrayInstanzenObject as $instanz ){
			$this->IpsSwitchScript.=$instanz->toIpsSwitchFunktion();
			foreach ($instanz->getInstanzArray() as $instanzsub){
				$this->IpsSwitchScript.=$instanzsub->toIpsSwitchFunktion();
			}
		}
		return $this->IpsSwitchScript;
	}
	// Schreibt den Java-Script für alle Kategorien für die Navigation(z.B. Wohnung->Wohnzimmer)  die unter der Katergorie liegen
	public function toHauptmenueJavaScriptVar($Start) {
		$textVar = $Start->getName().$Start->getID();
		$textVar = Utility::umlaute_ersetzen(utf8_encode($textVar));
		$this->JavaScript = "";
		$this->JavaScript.="var ".$textVar." = $('#".$textVar."');";
		$this->JavaScript.="\n";
		foreach ($this->ArrayKategorienObject as $object ){
			$textVar = $object->getName().$object->getID();
			$textVar = Utility::umlaute_ersetzen(utf8_encode($textVar));
			$this->JavaScript.="var ".$textVar." = $('#".$textVar."');";
			$this->JavaScript.="\n";
		}
		return $this->JavaScript;
	}
	// Schreibt den Java-Script für alle Kategorien die die Kategorien als Variablen setzen  die unter der Katergorie liegen
	public function toJavaScriptVar($Start) {
		$this->JavaScript = "";
		foreach ($this->ArrayKategorienObject as $object ){
			$textVar = $object->getName().$object->getID();
			$textVar = Utility::umlaute_ersetzen(utf8_encode($textVar));
			$this->JavaScript.="var ".$textVar." = $('#".$textVar."');";
			$this->JavaScript.="\n";
		}
		return $this->JavaScript;
	}
	// Schreibt den Java-Script für den Aufruf der Navigation zwischen den Kategorien die unter der Katergorie liegen
	public function toHauptmenueJavaScriptFunktion($Start) {
		$textVar = $Start->getName().$Start->getID();
		$textVar = Utility::umlaute_ersetzen(utf8_encode($textVar));
		$this->JavaScript = "";
		$this->JavaScript.=$textVar.".live('pageinit',function(event){";
		$this->JavaScript.="\n";
		$this->JavaScript.=$textVar.".ips".$textVar."(".$textVar.");";
		$this->JavaScript.="\n";
		foreach ($this->ArrayKategorienObject as $object ){
			$textObjectVar = $object->getName().$object->getID();
			$textObjectVar = Utility::umlaute_ersetzen(utf8_encode($textObjectVar));
			$this->JavaScript.=$textVar.".ips".$textObjectVar."(".$textVar.");";
			$this->JavaScript.="\n";
		}
		return $this->JavaScript;
	}
	// Schreibt den Java-Script für das setzen der Variablen der Kategorien auf der Strtseite die unter der Katergorie liegen
	public function toJavaScriptFunktion($Start,$Startname) {
		$this->JavaScript = "";
		foreach ($this->ArrayKategorienObject as $object ){
			$textVar = $object->getName().$object->getID();
			$textVar = Utility::umlaute_ersetzen(utf8_encode($textVar));
			$this->JavaScript.=$Startname.".ips".$textVar."(".$Startname.");";
			$this->JavaScript.="\n";
		}
		return $this->JavaScript;
	}
	// Schreibt den Java-Script für die Refresh-Button und Auto-Refresh die unter der Katergorie liegen
	public function toHauptmenueJavaScriptRefresh($Start) {
		$this->JavaScript = "";
		$textVar = $Start->getName().$Start->getID();
		$textVar = Utility::umlaute_ersetzen(utf8_encode($textVar));
		$this->JavaScript.="$('#refresh".$Start->getID()."').live('click', function() {";
		$this->JavaScript.="\n";
		$this->JavaScript.="var page=$(this);";
		$this->JavaScript.="\n";
		$this->JavaScript.=$textVar.".ips".$textVar."(".$textVar.");";
		$this->JavaScript.="\n";
		$this->avaScript.="page.trigger('create');";
		$this->JavaScript.="\n";
		$this->JavaScript.="});";
		$this->JavaScript.="\n";
		$this->JavaScript.=$textVar.".live('pageinit',function(event){";
		$this->JavaScript.="\n";
		$this->JavaScript.=$textVar.".ips".$textVar."(".$textVar.");";
		$this->JavaScript.="\n";
		$this->JavaScript.="\n";
		$this->JavaScript.="var auto_refresh = setInterval(";
		$this->JavaScript.="\n";
		$this->JavaScript.="function (){";
		$this->JavaScript.="\n";
		$this->JavaScript.=$textVar.".ips".$textVar."(".$textVar.");";
		$this->JavaScript.="\n";
		$this->JavaScript.="var page = ".$textVar.";";
		$this->JavaScript.="\n";
		$this->JavaScript.="page.trigger('create');";
		$this->JavaScript.="\n";
		$this->JavaScript.="}, 5000);";
		$this->JavaScript.="\n";
		$this->JavaScript.="});";
		$this->JavaScript.="\n";
		foreach ($this->ArrayKategorienObject as $object ){
			$textVar = $object->getName().$object->getID();
			$textVar = Utility::umlaute_ersetzen(utf8_encode($textVar));
			$this->JavaScript.="$('#refresh".$object->getID()."').live('click', function() {";
			$this->JavaScript.="\n";
			$this->JavaScript.="var page=$(this);";
			$this->JavaScript.="\n";
			$this->JavaScript.=$textVar.".ips".$textVar."(".$textVar.");";
			$this->JavaScript.="\n";
			$this->JavaScript.="page.trigger('create');";
			$this->JavaScript.="\n";
			$this->JavaScript.="});";
			$this->JavaScript.="\n";
			$this->JavaScript.=$textVar.".live('pageinit',function(event){";
			$this->JavaScript.="\n";
			$this->JavaScript.=$textVar.".ips".$textVar."(".$textVar.");";
			$this->JavaScript.="\n";
			$this->JavaScript.="var auto_refresh = setInterval(";
			$this->JavaScript.="\n";
			$this->JavaScript.="function (){";
			$this->JavaScript.="\n";
			$this->JavaScript.=$textVar.".ips".$textVar."(".$textVar.");";
			$this->JavaScript.="\n";
			$this->JavaScript.="var page = ".$textVar.";";
			$this->JavaScript.="\n";
			$this->JavaScript.="page.trigger('create');";
			$this->JavaScript.="\n";
			$this->JavaScript.="	}, 5000);";
			$this->JavaScript.="\n";
			$this->JavaScript.="});";
			$this->JavaScript.="\n";
		}
		return $this->JavaScript;
	}
	// Schreibt den Java-Script für die Refresh-Button und Auto-Refresh auf der Startseite
	public function toJavaScriptRefresh($Start) {
		$this->JavaScript = "";
		foreach ($this->ArrayKategorienObject as $object ){
			$textVar = $object->getName().$object->getID();
			$textVar = Utility::umlaute_ersetzen(utf8_encode($textVar));
			$this->JavaScript.="$('#refresh".$object->getID()."').live('click', function() {";
			$this->JavaScript.="\n";
			$this->JavaScript.="var page=$(this);";
			$this->JavaScript.="\n";
			$this->JavaScript.=$textVar.".ips".$textVar."(".$textVar.");";
			$this->JavaScript.="\n";
			$this->JavaScript.="page.trigger('create');";
			$this->JavaScript.="\n";
			$this->JavaScript.="});";
			$this->JavaScript.="\n";
			$this->JavaScript.=$textVar.".live('pageinit',function(event){";
			$this->JavaScript.="\n";
			$this->JavaScript.=$textVar.".ips".$textVar."(".$textVar.");";
			$this->JavaScript.="\n";
			$this->JavaScript.="var auto_refresh = setInterval(";
			$this->JavaScript.="\n";
			$this->JavaScript.="function (){";
			$this->JavaScript.="\n";
			$this->JavaScript.=$textVar.".ips".$textVar."(".$textVar.");";
			$this->JavaScript.="\n";
			$this->JavaScript.="var page = ".$textVar.";";
			$this->JavaScript.="\n";
			$this->JavaScript.="page.trigger('create');";
			$this->JavaScript.="\n";
			$this->JavaScript.="	}, 5000);";
			$this->JavaScript.="\n";
			$this->JavaScript.="});";
			$this->JavaScript.="\n";
		}
		return $this->JavaScript;
	}
}
?>
