<?php
/**
 * Description of Kategorie
 * Diese Klasse gibt das IPS-Systems in Html und Java-Script aus
 * @author Dirk Kruck
 */
include'Kategorie.php';
include'Instanz.php';
include'Variable.php';
include'Script.php';
include'Ereignis.php';
include'HashMap.php';

class Page {
	private $HauptmenueJavaScriptVar ="";
	private $JavaScriptVar = "";
	private $JavaScriptLocalStorage = "";
	private $HtmlEinstellungsseite = "";
	private $HauptmenueJavaScriptFunktion = "";
	private $HauptmenueJavaScriptRefresh= "";
	private $JavaScriptFunktion = "";
	private $JavaScriptRefresh= "";
	private $JavaScriptHead = "";
	private $JavaScriptFood = "";
	private $HtmlSeiten = "";
	private $HtmlHead = "";
	private $HtmlFood = "";
	private $IpsStart = "";
	private $IpsGetFunktion = "";
	private $IpsSetFunktion = "";
	private $HauptmenueIpsGetFunktion ="";
	private $HauptmenueIpsSetFunktion ="";
	private $ObjektListe = null;
	private $Quelle = null;
	private $HauptmenueIpsAufruf =  "";
	private $IpsSwitchAufruf = "";
	private $Graph = "";
	private $GraphScript = "";
	private $GraphAufruf = "";
	private $SwitchBooleanScript = "";
	private $IpsSwitchBooleanScript = "";
	private $HtmlScriptStartenScript = "";
	private $IpsScriptStartenScript = "";
	private $SliderAufrufScript = "";
	private $Version = "0.1";

	public function __construct(){
		$this->ObjektListe = new HashMap();
	}
	public function toHauptmenueHtml($Start){
		global $HtmlSeiten;
		$textVar = $Start->getName().$Start->getID();
		$textVar = Utility::umlaute_ersetzen(utf8_encode($textVar));
		$HtmlSeiten.="<div data-role='page'"." id='".$textVar."'"." data-theme='a'>";
		$HtmlSeiten.="\n";
		$HtmlSeiten.="<div data-role='header' data-theme='b'>";
		$HtmlSeiten.="\n";
		$HtmlSeiten.="<a href='#'  id='refresh".$Start->getId()."' data-icon='refresh' class='ui-btn-right'>Refresh</a>";
		$HtmlSeiten.="\n";
		$HtmlSeiten.="<h1>".$Start->getName()."</h1>";
		$HtmlSeiten.="\n";
		$HtmlSeiten.="</div>";
		$HtmlSeiten.="\n";
		$HtmlSeiten.="<div data-role='content'>";
		$HtmlSeiten.="\n";
		$HtmlSeiten.="<ul data-role='listview' id="."'"."Liste".$Start->getName().$Start->getId()."'".">";
		$HtmlSeiten.="\n";
		$HtmlSeiten.= $Start->toKategorieHtml();
		$HtmlSeiten.="</ul>";
		$HtmlSeiten.="\n";
		$HtmlSeiten.="</div>";
		$HtmlSeiten.="\n";
		$HtmlSeiten.="<div data-role='footer' data-theme='b'>";
		$HtmlSeiten.="\n";
		$HtmlSeiten.="<h4>&copy; 2012 by Dirk Kruck&nbsp;&nbsp;&nbsp;Version ".$this->Version."</h4>";
		$HtmlSeiten.="\n";
		$HtmlSeiten.="</div>";
		$HtmlSeiten.="\n";
		$HtmlSeiten.="</div>";
		$HtmlSeiten.="\n";
	}

	public function toKategorieHtml($Start){
		global $HtmlSeiten;
		$KatArray = $Start->getKategorieArray();
	 foreach ($KatArray as $object ){
	 	$textVar = $object->getName().$object->getID();
	 	$textVar = Utility::umlaute_ersetzen(utf8_encode($textVar));
	 	$HtmlSeiten.="<div data-role='page'"." id="."'".$textVar."'"." data-theme='a'>";
	 	$HtmlSeiten.="\n";
	 	$HtmlSeiten.="<div data-role='header' data-theme='b'>";
	 	$HtmlSeiten.="\n";
	 	$HtmlSeiten.="<a href='#' id='refresh".$object->getId()."'' data-icon='refresh' class='ui-btn-right'>Refresh</a>";
	 	$HtmlSeiten.="\n";
	 	$HtmlSeiten.="<h1>".$object->getName()."</h1>";
	 	$HtmlSeiten.="\n";
	 	$HtmlSeiten.="</div>";
	 	$HtmlSeiten.="\n";
	 	$HtmlSeiten.="<div data-role='content'>";
	 	$HtmlSeiten.="\n";
	 	$HtmlSeiten.="<ul data-role='listview' id="."'"."Liste".$textVar."'".">";
	 	$HtmlSeiten.="\n";
	 	$HtmlSeiten.=$object->toKategorieHtml();
	 	$HtmlSeiten.="\n";
	 	$HtmlSeiten.="</ul>";
	 	$HtmlSeiten.="\n";
	 	$HtmlSeiten.="</div>";
	 	$HtmlSeiten.="\n";
	 	$HtmlSeiten.="<div data-role='footer' data-theme='b'>";
	 	$HtmlSeiten.="\n";
	 	$HtmlSeiten.="<h4>&copy; 2012 by Dirk Kruck&nbsp;&nbsp;&nbsp;Version ".$this->Version."</h4>";
	 	$HtmlSeiten.="\n";
	 	$HtmlSeiten.="</div>";
	 	$HtmlSeiten.="\n";
	 	$HtmlSeiten.="</div>";
	 	$HtmlSeiten.="\n";
	 	$this->toKategorieHtml($object);
	 }
	 return utf8_encode($HtmlSeiten);
	}

	public  function toHauptmenueJavaScriptVar($Start){
		global $HauptmenueJavaScriptVar;
		$HauptmenueJavaScriptVar.=$Start->toHauptmenueJavaScriptVar($Start);
		return utf8_encode($HauptmenueJavaScriptVar);
	}

	public  function toJavaScriptVar($Start){
		global $JavaScriptVar;
		$KatArray = $Start->getKategorieArray();
	 foreach ($KatArray as $object ){
	 	$JavaScriptVar.=$object->toJavaScriptVar($Start);
	 	$this->toJavaScriptVar($object);
	 }
	 return utf8_encode($JavaScriptVar);
	}

	public function toEinstellungsseite(){
		$this->HtmlEinstellungsseite.="<div data-role='page' id='Einstellung' data-theme='a'>";
		$this->HtmlEinstellungsseite.="\n";
		$this->HtmlEinstellungsseite.="<div data-role='header' data-theme='b'>";
		$this->HtmlEinstellungsseite.="\n";
		$this->HtmlEinstellungsseite.="<a href='#' id='refresh12453'' data-icon='refresh' class='ui-btn-right'>Refresh</a>";
		$this->HtmlEinstellungsseite.="\n";
		$this->HtmlEinstellungsseite.="<h1>Einstellung</h1>";
		$this->HtmlEinstellungsseite.="\n";
		$this->HtmlEinstellungsseite.="</div>";
		$this->HtmlEinstellungsseite.="\n";
		$this->HtmlEinstellungsseite.="<div data-role='content'>";
		$this->HtmlEinstellungsseite.="\n";
		$this->HtmlEinstellungsseite.="	Es sind Einstellungen vorzunehmen";
		$this->HtmlEinstellungsseite.="\n";
		$this->HtmlEinstellungsseite.="<ul data-role='listview' id='ListeWecker12453'>";
		$this->HtmlEinstellungsseite.="\n";
		$this->HtmlEinstellungsseite.="</ul>";
		$this->HtmlEinstellungsseite.="\n";
		$this->HtmlEinstellungsseite.="</div>";
		$this->HtmlEinstellungsseite.="\n";
		$this->HtmlEinstellungsseite.="<div data-role='footer' data-theme='b'>";
		$this->HtmlEinstellungsseite.="\n";
		$this->HtmlEinstellungsseite.="<h4>&copy; 2012 by Dirk Kruck&nbsp;&nbsp;&nbsp;Version ".$this->Version."</h4>";
		$this->HtmlEinstellungsseite.="\n";
		$this->HtmlEinstellungsseite.="</div>";
		$this->HtmlEinstellungsseite.="\n";
		$this->HtmlEinstellungsseite.="</div>";
		return utf8_encode($this->HtmlEinstellungsseite);
	}

	public function tolocalStorage(){
		$this->JavaScriptLocalStorage.="$('#Home').live('pagebeforecreate',function(event){";
		$this->JavaScriptLocalStorage.="\n";
		$this->JavaScriptLocalStorage.="if(localStorage.length == 0){";
		$this->JavaScriptLocalStorage.="\n";
		$this->JavaScriptLocalStorage.="$.mobile.changePage('#Einstellung');";
		$this->JavaScriptLocalStorage.="}else{";
		$this->JavaScriptLocalStorage.="\n";
		$this->JavaScriptLocalStorage.="$.mobile.changePage('#Haussteuerung10987');";
		$this->JavaScriptLocalStorage.="\n";
		$this->JavaScriptLocalStorage.="}";
		$this->JavaScriptLocalStorage.="\n";
		$this->JavaScriptLocalStorage.="});";
		$this->JavaScriptLocalStorage.="\n";
		return utf8_encode($this->JavaScriptLocalStorage);
	}
	public function toGraph(){
		$this->Graph.="<div  data-role='dialog'  id='graphpage' data-theme='a'>";
		$this->Graph.="\n";
		$this->Graph.="<div data-role='header' data-theme='b'>";
		$this->Graph.="\n";
		$this->Graph.="<h1>Graph</h1>";
		$this->Graph.="\n";
		$this->Graph.="</div>";
		$this->Graph.="\n";
		$this->Graph.="<div data-role='content'>";
		$this->Graph.="\n";
		$this->Graph.="<div id='chart1' style='height:300px; width:400px;'>";
		$this->Graph.="\n";
		$this->Graph.="</div>";
		$this->Graph.="\n";
		$this->Graph.="</div>";
		$this->Graph.="\n";
		$this->Graph.="</div>";
		$this->Graph.="\n";
		return utf8_encode($this->Graph);
	}
	public  function toHauptmenueJavaScriptFunktion($Start){
		global $HauptmenueJavaScriptFunktion;
		$HauptmenueJavaScriptFunktion.=$Start->toHauptmenueJavaScriptFunktion($Start);
		return utf8_encode($HauptmenueJavaScriptFunktion);
	}


	public  function toJavaScriptFunktion($Start,$Startname){
		$KatArray = $Start->getKategorieArray();
	 foreach ($KatArray as $object ){
	 	$this->JavaScriptFunktion.=$object->toJavaScriptFunktion($Start,$Startname);
	 	$this->toJavaScriptFunktion($object,$Startname);
	 }
	 return utf8_encode($this->JavaScriptFunktion);
	}
	public  function toHauptmenueJavaScriptRefresh($Start){
		$this->HauptmenueJavaScriptRefresh.=$Start->toHauptmenueJavaScriptRefresh($Start);
		return utf8_encode($this->HauptmenueJavaScriptRefresh);
	}

	public  function toJavaScriptRefresh($Start){
		$KatArray = $Start->getKategorieArray();
	 foreach ($KatArray as $object ){
	 	$this->JavaScriptRefresh.=$object->toJavaScriptRefresh($Start);
	 	$this->toJavaScriptRefresh($object);
	 }
	 return utf8_encode($this->JavaScriptRefresh);
	}

	public function toKlammer(){
		$JavaScriptKlammer="";
		$JavaScriptKlammer.="});";
		$JavaScriptKlammer.="\n";
		return utf8_encode($JavaScriptKlammer);
	}

	public function toHeadHtml($Server){
		global $HtmlHead;
		$HtmlHead.="<!DOCTYPE html>";
		$HtmlHead.="\n";
		$HtmlHead.="<html manifest='manifest.php'>";
		$HtmlHead.="\n";
		$HtmlHead.="<head>";
		$HtmlHead.="\n";
		$HtmlHead.="<meta charset='UTF-8' />";
		$HtmlHead.="\n";
		$HtmlHead.="<meta name='viewport'";
		$HtmlHead.="\n";
		$HtmlHead.="content='width=device-width, initial-scale=1'/>";
		$HtmlHead.="\n";
		$HtmlHead.="<title>jQuery Mobile-Webanwendung</title>";
		$HtmlHead.="\n";
		$HtmlHead.="<link rel='stylesheet' href='http://code.jquery.com/mobile/1.2.0/jquery.mobile-1.2.0.min.css' />";
		$HtmlHead.="\n";
		$HtmlHead.="<link href='jquery-mobile/samsungS3.css' rel='stylesheet' type='text/css' media='only screen and (max-width:730px)'>";
		$HtmlHead.="\n";
		$HtmlHead.="<!-- Tablet -->";
		$HtmlHead.="\n";
		$HtmlHead.="<!--link href='jquery-mobile/GalaxyTab.css' rel='stylesheet' type='text/css' media='only screen and (min-width:321px) and (max-width:768px)'-->";
		$HtmlHead.="\n";
		$HtmlHead.="<!-- Tablet Acer -->";
		$HtmlHead.="\n";
		$HtmlHead.="<!--link href='jquery-mobile/acera500.css' rel='stylesheet' type='text/css' media='only screen and (max-width:800px)'-->";
		$HtmlHead.="\n";
		$HtmlHead.="<!-- Desktop -->";
		$HtmlHead.="\n";
		$HtmlHead.="<link href='jquery-mobile/desktop.css' rel='stylesheet' type='text/css' media='only screen and (min-width:800px) and (max-width:1280px)'>";
		$HtmlHead.="\n";
		$HtmlHead.="<script src='http://code.jquery.com/jquery-1.8.1.min.js'></script>";
		$HtmlHead.="\n";
		$HtmlHead.="<script src='http://code.jquery.com/mobile/1.2.0/jquery.mobile-1.2.0.min.js'></script>";
		$HtmlHead.="\n";
		$HtmlHead.="<script type='text/javascript' src='jqplot/jquery.jqplot.min.js'></script>";
		$HtmlHead.="\n";
		$HtmlHead.="<script type='text/javascript' src='jqplot/plugins/jqplot.json2.min.js'></script>";
		$HtmlHead.="\n";
		$HtmlHead.="<script type='text/javascript' src='jqplot/plugins/jqplot.canvasTextRenderer.min.js'></script>";
		$HtmlHead.="\n";
		$HtmlHead.="<script type='text/javascript' src='jqplot/plugins/jqplot.canvasAxisLabelRenderer.min.js'></script>";
		$HtmlHead.="\n";
		$HtmlHead.="<script src='jquery-mobile/ips.js' type='text/javascript'></script>";
		$HtmlHead.="\n";
		$HtmlHead.="<script type='text/javascript'>";
		$HtmlHead.="\n";
		$HtmlHead.="sessionStorage.Server = ".$Server.";";
		$HtmlHead.="\n";
		$HtmlHead.="$( document ).bind( 'mobileinit', function() {";
		$HtmlHead.="\n";
		$HtmlHead.="$.mobile.allowCrossDomainPages = true;";
		$HtmlHead.="\n";
		$HtmlHead.="$.mobile.support.cors = true;";
		$HtmlHead.="\n";
		$HtmlHead.="});";
		$HtmlHead.="\n";
		$HtmlHead.="</script>";
		$HtmlHead.="\n";
		$HtmlHead.="</head>";
		$HtmlHead.="\n";
		$HtmlHead.="<body>";
		$HtmlHead.="\n";
		return utf8_encode($HtmlHead);
	}

	public function toHeadJavaScript(){
		global $JavaScriptHead;
		$JavaScriptHead.="<script type='text/javascript'>";
		$JavaScriptHead.="\n";
		return utf8_encode($JavaScriptHead);
	}

	public function toFoodJavaScript(){
		global $JavaScriptFood;
		$JavaScriptFood.="</script>";
		$JavaScriptFood.="\n";
		return utf8_encode($JavaScriptFood);
	}

	public function toFoodHtml(){
		global $HtmlFood;
		$HtmlFood.="</body>";
		$HtmlFood.="\n";
		$HtmlFood.="</html>";
		$HtmlFood.="\n";
		return utf8_encode($HtmlFood);
	}
	public function toIpsStart(){
		$this->IpsStart.="(function($) {";
		$this->IpsStart.="\n";
		$this->IpsStart.="$.fn.ipsinteger= function(rpc,idn,methode,param,typ,objekt,einheit) {";
		$this->IpsStart.="\n";
		$this->IpsStart.="var parameter = parseInt(param);";
		$this->IpsStart.="\n";
		$this->IpsStart.="		 $.ajax({";
		$this->IpsStart.="\n";
		$this->IpsStart.="          url: sessionStorage.Server + '/json-rpc.php',";
		$this->IpsStart.="\n";
		$this->IpsStart.="          data: JSON.stringify ({jsonrpc :rpc,id:idn,method:methode,params:[parameter]} ),  // id is needed !!";
		$this->IpsStart.="\n";
		$this->IpsStart.="          type:'POST',";
		$this->IpsStart.="\n";
		$this->IpsStart.="          dataType:'json',";
		$this->IpsStart.="\n";
		$this->IpsStart.="          success:  function (data) {";
		$this->IpsStart.="\n";
		$this->IpsStart.="          	if(einheit == ''){";
		$this->IpsStart.="\n";
		$this->IpsStart.="		var now = new Date(data.result*1000);";
		$this->IpsStart.="\n";
		$this->IpsStart.="		$(objekt).text(now.toLocaleDateString()+',' + now.toLocaleTimeString());";
		$this->IpsStart.="\n";
		$this->IpsStart.="	}else{";
		$this->IpsStart.="\n";
		$this->IpsStart.="		$(objekt).text(data.result+' '+ einheit);";
		$this->IpsStart.="\n";
		$this->IpsStart.="	}";
		$this->IpsStart.="\n";
		$this->IpsStart.="          	},";
		$this->IpsStart.="\n";
		$this->IpsStart.="          //error: function (err)  { alert (err);}";
		$this->IpsStart.="\n";
		$this->IpsStart.="       });";
		$this->IpsStart.="\n";
		$this->IpsStart.="}";
		$this->IpsStart.="\n";
		$this->IpsStart.="})(jQuery);";
		$this->IpsStart.="\n";
		$this->IpsStart.="\n";
		$this->IpsStart.="(function($) {";
		$this->IpsStart.="\n";
		$this->IpsStart.="$.fn.ipsfloat= function(rpc,idn,methode,param,typ,objekt,einheit) {";
		$this->IpsStart.="\n";
		$this->IpsStart.="var parameter = parseInt(param);";
		$this->IpsStart.="\n";
		$this->IpsStart.="		 $.ajax({";
		$this->IpsStart.="\n";
		$this->IpsStart.="          url: sessionStorage.Server + '/json-rpc.php',";
		$this->IpsStart.="\n";
		$this->IpsStart.="          data: JSON.stringify ({jsonrpc :rpc,id:idn,method:methode,params:[parameter]} ),  // id is needed !!";
		$this->IpsStart.="\n";
		$this->IpsStart.="          type:'POST',";
		$this->IpsStart.="\n";
		$this->IpsStart.="          dataType:'json',";
		$this->IpsStart.="\n";
		$this->IpsStart.="          success:  function (data)       {";
		$this->IpsStart.="\n";
		$this->IpsStart.="         if(typ == 1){";
		$this->IpsStart.="\n";
		$this->IpsStart.="         if(einheit == '%' || einheit == ' %'){";
		$this->IpsStart.="\n";
		$this->IpsStart.="          	$(objekt).text(parseInt(data.result)+' '+ einheit);";
		$this->IpsStart.="\n";
		$this->IpsStart.="          	}else{";
		$this->IpsStart.="\n";
		$this->IpsStart.="          	$(objekt).text(data.result+' '+ einheit);";
		$this->IpsStart.="\n";
		$this->IpsStart.="          	}";
		$this->IpsStart.="\n";
		$this->IpsStart.="          	}else if(typ == 2){";
		$this->IpsStart.="\n";
		$this->IpsStart.="          	$(objekt).val(data.result);";
		$this->IpsStart.="\n";
		$this->IpsStart.="          	$(objekt).slider('refresh');";
		$this->IpsStart.="\n";
		$this->IpsStart.="          	}";
		$this->IpsStart.="\n";
		$this->IpsStart.="          	},";
		$this->IpsStart.="\n";
		$this->IpsStart.="          //error: function (err)  { alert (err);}";
		$this->IpsStart.="\n";
		$this->IpsStart.="       });";
		$this->IpsStart.="\n";
		$this->IpsStart.="}";
		$this->IpsStart.="\n";
		$this->IpsStart.="})(jQuery);";
		$this->IpsStart.="\n";
		$this->IpsStart.="\n";
		$this->IpsStart.="(function($) {";
		$this->IpsStart.="\n";
		$this->IpsStart.="$.fn.ipsstring= function(rpc,idn,methode,param,typ,objekt) { ";
		$this->IpsStart.="\n";
		$this->IpsStart.="var parameter = parseInt(param);";
		$this->IpsStart.="\n";
		$this->IpsStart.="		 $.ajax({";
		$this->IpsStart.="\n";
		$this->IpsStart.="        	url: sessionStorage.Server + '/json-rpc.php', ";
		$this->IpsStart.="\n";
		$this->IpsStart.="          data: JSON.stringify ({jsonrpc :rpc,id:idn,method:methode,params:[parameter]} ),  // id is needed !!";
		$this->IpsStart.="\n";
		$this->IpsStart.="          type:'POST',";
		$this->IpsStart.="\n";
		$this->IpsStart.="          dataType:'json',";
		$this->IpsStart.="\n";
		$this->IpsStart.="          success:  function (data)       {";
		$this->IpsStart.="\n";
		$this->IpsStart.="          	$(objekt).text(data.result);";
		$this->IpsStart.="\n";
		$this->IpsStart.="         	},";
		$this->IpsStart.="\n";
		$this->IpsStart.="          //error: function (err)  { alert (err);}";
		$this->IpsStart.="\n";
		$this->IpsStart.="       });";
		$this->IpsStart.="\n";
		$this->IpsStart.="}";
		$this->IpsStart.="\n";
		$this->IpsStart.="})(jQuery);";
		$this->IpsStart.="\n";
		$this->IpsStart.="\n";
		$this->IpsStart.="(function($) {";
		$this->IpsStart.="\n";
		$this->IpsStart.="$.fn.ipsscript= function(rpc,idn,methode,param,objekt) { ";
		$this->IpsStart.="\n";
		$this->IpsStart.="var parameter = parseInt(param);";
		$this->IpsStart.="\n";
		$this->IpsStart.="		 $.ajax({";
		$this->IpsStart.="\n";
		$this->IpsStart.="          url: sessionStorage.Server + '/json-rpc.php', ";
		$this->IpsStart.="\n";
		$this->IpsStart.="          data: JSON.stringify ({jsonrpc :rpc,id:idn,method:methode,params:[parameter]} ),  // id is needed !!";
		$this->IpsStart.="\n";
		$this->IpsStart.="          type:'POST',";
		$this->IpsStart.="\n";
		$this->IpsStart.="          dataType:'json',";
		$this->IpsStart.="\n";
		$this->IpsStart.="          success:  function (data)       {";
		$this->IpsStart.="\n";
		$this->IpsStart.="         	},";
		$this->IpsStart.="\n";
		$this->IpsStart.="          //error: function (err)  { alert (err);}";
		$this->IpsStart.="\n";
		$this->IpsStart.="       });";
		$this->IpsStart.="\n";
		$this->IpsStart.="}";
		$this->IpsStart.="\n";
		$this->IpsStart.="})(jQuery);";
		$this->IpsStart.="\n";
		$this->IpsStart.="\n";
		$this->IpsStart.="(function($) {";
		$this->IpsStart.="\n";
		$this->IpsStart.="$.fn.ipsboolean= function(rpc,idn,methode,param,typ,objekt,einheit,einheit1) {";
		$this->IpsStart.="\n";
		$this->IpsStart.="var parameter = parseInt(param);";
		$this->IpsStart.="\n";
		$this->IpsStart.="		 $.ajax({";
		$this->IpsStart.="\n";
		$this->IpsStart.="          url: sessionStorage.Server + '/json-rpc.php',";
		$this->IpsStart.="\n";
		$this->IpsStart.="          data: JSON.stringify ({jsonrpc :rpc,id:idn,method:methode,params:[parameter]} ),  // id is needed !!";
		$this->IpsStart.="\n";
		$this->IpsStart.="          type:'POST',";
		$this->IpsStart.="\n";
		$this->IpsStart.="          dataType:'json',";
		$this->IpsStart.="\n";
		$this->IpsStart.="          success:  function (data)       {";
		$this->IpsStart.="\n";
		$this->IpsStart.="          	if(!data.result){";
		$this->IpsStart.="\n";
		$this->IpsStart.="		$(objekt).text(einheit);";
		$this->IpsStart.="\n";
		$this->IpsStart.="	}else{";
		$this->IpsStart.="\n";
		$this->IpsStart.="		$(objekt).text(einheit1);";
		$this->IpsStart.="\n";
		$this->IpsStart.="	}";
		$this->IpsStart.="\n";
		$this->IpsStart.="          	},";
		$this->IpsStart.="\n";
		$this->IpsStart.="         //error: function (err)  { alert (err);}";
		$this->IpsStart.="\n";
		$this->IpsStart.="       });";
		$this->IpsStart.="\n";
		$this->IpsStart.="}";
		$this->IpsStart.="\n";
		$this->IpsStart.="})(jQuery);";
		$this->IpsStart.="\n";
		$this->IpsStart.="(function($) {";
		$this->IpsStart.="\n";
		$this->IpsStart.="$.fn.ipsbooleansw= function(rpc,idn,methode,param,objekt,einheit,einheit1) {";
		$this->IpsStart.="\n";
		$this->IpsStart.="var parameter = parseInt(param);";
		$this->IpsStart.="\n";
		$this->IpsStart.="		 $.ajax({";
		$this->IpsStart.="\n";
		$this->IpsStart.="          url: sessionStorage.Server + '/json-rpc.php',";
		$this->IpsStart.="\n";
		$this->IpsStart.="          data: JSON.stringify ({jsonrpc :rpc,id:idn,method:methode,params:[parameter]} ),  // id is needed !!";
		$this->IpsStart.="\n";
		$this->IpsStart.="          type:'POST',";
		$this->IpsStart.="\n";
		$this->IpsStart.="          dataType:'json',";
		$this->IpsStart.="\n";
		$this->IpsStart.="          success:  function (data)       {";
		$this->IpsStart.="\n";
		$this->IpsStart.="          	 var fts = $(objekt);";
		$this->IpsStart.="\n";
		$this->IpsStart.="          	if(!data.result){";
		$this->IpsStart.="\n";
		$this->IpsStart.="		 fts.val('off');";
		$this->IpsStart.="\n";
		$this->IpsStart.="		 fts.slider('refresh');";
		$this->IpsStart.="\n";
		$this->IpsStart.="	}else{";
		$this->IpsStart.="\n";
		$this->IpsStart.="		 fts.val('on');";
		$this->IpsStart.="\n";
		$this->IpsStart.="		 fts.slider('refresh');";
		$this->IpsStart.="\n";
		$this->IpsStart.="	}";
		$this->IpsStart.="\n";
		$this->IpsStart.="          	},";
		$this->IpsStart.="\n";
		$this->IpsStart.="          //error: function (err)  { alert (err);}";
		$this->IpsStart.="\n";
		$this->IpsStart.="       });";
		$this->IpsStart.="\n";
		$this->IpsStart.="}";
		$this->IpsStart.="\n";
		$this->IpsStart.="})(jQuery);";
		$this->IpsStart.="\n";
		$this->IpsStart.="(function($) {";
		$this->IpsStart.="\n";
		$this->IpsStart.="$.fn.ipsswitch= function(rpc,idn,methode,param,param1,objekt,einheit,einheit1) {";
		$this->IpsStart.="\n";
		$this->IpsStart.="var parameter = parseInt(param);";
		$this->IpsStart.="\n";
		$this->IpsStart.="var parameter1 = Boolean(param1);";
		$this->IpsStart.="\n";
		$this->IpsStart.="	 $.ajax({";
		$this->IpsStart.="\n";
		$this->IpsStart.="        url: sessionStorage.Server + '/json-rpc.php',";
		$this->IpsStart.="\n";
		$this->IpsStart.="        data: JSON.stringify ({jsonrpc :rpc,id:idn,method:methode,params:[parameter,parameter1]} ),  // id is needed !!";
		$this->IpsStart.="\n";
		$this->IpsStart.="        type:'POST',";
		$this->IpsStart.="\n";
		$this->IpsStart.="        dataType:'json',";
		$this->IpsStart.="\n";
		$this->IpsStart.="        success:  function (data)       {";
		$this->IpsStart.="\n";
		$this->IpsStart.="        	var fts = $(objekt);";
		$this->IpsStart.="\n";
		$this->IpsStart.="if(parameter1){";
		$this->IpsStart.="\n";
		$this->IpsStart.="		fts.val('on');";
		$this->IpsStart.="\n";
		$this->IpsStart.="		fts.slider('refresh');";
		$this->IpsStart.="\n";
		$this->IpsStart.="}else{";
		$this->IpsStart.="\n";
		$this->IpsStart.="		fts.val('off');";
		$this->IpsStart.="\n";
		$this->IpsStart.="		fts.slider('refresh');";
		$this->IpsStart.="\n";
		$this->IpsStart.="}";
		$this->IpsStart.="\n";
		$this->IpsStart.="        	},";
		$this->IpsStart.="\n";
		$this->IpsStart.="        //error: function (err)  { alert (err);}";
		$this->IpsStart.="\n";
		$this->IpsStart.="     });";
		$this->IpsStart.="\n";
		$this->IpsStart.="}";
		$this->IpsStart.="\n";
		$this->IpsStart.="})(jQuery);";
		$this->IpsStart.="\n";
		$this->IpsStart.="\n";
		$this->IpsStart.="(function($) {";
		$this->IpsStart.="\n";
		$this->IpsStart.="$.fn.homematicswitch= function(rpc,idn,methode,param,param1,param2,objekt,einheit,einheit1) {";
		$this->IpsStart.="\n";
		$this->IpsStart.="var parameter = parseInt(param);";
		$this->IpsStart.="\n";
		$this->IpsStart.="var parameter1 = String(param1);";
		$this->IpsStart.="\n";
		$this->IpsStart.="var parameter2 = Boolean(param2);";
		$this->IpsStart.="\n";
		$this->IpsStart.="	 $.ajax({";
		$this->IpsStart.="\n";
		$this->IpsStart.="        url: sessionStorage.Server + '/json-rpc.php',";
		$this->IpsStart.="\n";
		$this->IpsStart.="        data: JSON.stringify ({jsonrpc :rpc,id:idn,method:methode,params:[parameter,parameter1,parameter2]} ),  // id is needed !!";
		$this->IpsStart.="\n";
		$this->IpsStart.="        type:'POST',";
		$this->IpsStart.="\n";
		$this->IpsStart.="        dataType:'json',";
		$this->IpsStart.="\n";
		$this->IpsStart.="        success:  function (data)       {";
		$this->IpsStart.="\n";
		$this->IpsStart.="        	var fts = $(objekt);";
		$this->IpsStart.="\n";
		$this->IpsStart.="if(parameter2){";
		$this->IpsStart.="\n";
		$this->IpsStart.="		fts.val('on');";
		$this->IpsStart.="\n";
		$this->IpsStart.="		fts.slider('refresh');";
		$this->IpsStart.="\n";
		$this->IpsStart.="}else{";
		$this->IpsStart.="\n";
		$this->IpsStart.="		fts.val('off');";
		$this->IpsStart.="\n";
		$this->IpsStart.="		fts.slider('refresh');";
		$this->IpsStart.="\n";
		$this->IpsStart.="}";
		$this->IpsStart.="\n";
		$this->IpsStart.="        	},";
		$this->IpsStart.="\n";
		$this->IpsStart.="        //error: function (err)  { alert (err);}";
		$this->IpsStart.="\n";
		$this->IpsStart.="     });";
		$this->IpsStart.="\n";
		$this->IpsStart.="}";
		$this->IpsStart.="\n";
		$this->IpsStart.="})(jQuery);";
		$this->IpsStart.="\n";
		$this->IpsStart.="\n";
		$this->IpsStart.="(function($) {";
		$this->IpsStart.="\n";
		$this->IpsStart.="$.fn.ipsset= function(rpc,idn,methode,param,objekt,param1) {";
		$this->IpsStart.="\n";
		$this->IpsStart.="var parameter = parseInt(param);";
		$this->IpsStart.="\n";
		$this->IpsStart.="var parameter1 = parseFloat(param1);";
		$this->IpsStart.="\n";
		$this->IpsStart.="	 $.ajax({";
		$this->IpsStart.="\n";
		$this->IpsStart.="        url: sessionStorage.Server + '/json-rpc.php',";
		$this->IpsStart.="\n";
		$this->IpsStart.="        data: JSON.stringify ({jsonrpc :rpc,id:idn,method:methode,params:[parameter,parameter1]} ),  // id is needed !!";
		$this->IpsStart.="\n";
		$this->IpsStart.="        type:'POST',";
		$this->IpsStart.="\n";
		$this->IpsStart.="        dataType:'json',";
		$this->IpsStart.="\n";
		$this->IpsStart.="        success:  function (data)       {";
		$this->IpsStart.="\n";
		$this->IpsStart.="        	},";
		$this->IpsStart.="\n";
		$this->IpsStart.="        //error: function (err)  { alert (err);}";
		$this->IpsStart.="\n";
		$this->IpsStart.="     });";
		$this->IpsStart.="\n";
		$this->IpsStart.="}";
		$this->IpsStart.="\n";
		$this->IpsStart.="})(jQuery);";
		$this->IpsStart.="\n";
		$this->IpsStart.="\n";
		return utf8_encode($this->IpsStart);
	}


	public function toIpsGetFunktion($Start){
		$KatArray = $Start->getKategorieArray();
	 foreach ($KatArray as $object ){
			$textVar = $object->getName().$object->getID();
			$textVar = Utility::umlaute_ersetzen(utf8_encode($textVar));
			$this->IpsGetFunktion.="(function($) {";
			$this->IpsGetFunktion.="\n";
			$this->IpsGetFunktion.="$.fn.ips".$textVar."= function(homesite) {";
			$this->IpsGetFunktion.="\n";
			$this->IpsGetFunktion.= $object->toIpsGetFunktion();
			$this->IpsGetFunktion.="}";
			$this->IpsGetFunktion.="\n";
			$this->IpsGetFunktion.="})(jQuery);";
			$this->IpsGetFunktion.="\n";
			$this->toIpsGetFunktion($object);
	 }
	 return utf8_encode($this->IpsGetFunktion);
	}
	public function toIpsSetFunktion($Start){
		$KatArray = $Start->getKategorieArray();
	 foreach ($KatArray as $object ){
			$textVar = $object->getName().$object->getID();
			$textVar = Utility::umlaute_ersetzen(utf8_encode($textVar));
			$this->IpsSetFunktion.= $object->toIpsSetFunktion();
			$this->toIpsSetFunktion($object);
	 }
	 return utf8_encode($this->IpsSetFunktion);
	}
	public function toHauptmenueIpsGetFunktion($Start){
		$textVar = $Start->getName().$Start->getID();
		$textVar = Utility::umlaute_ersetzen(utf8_encode($textVar));
		$this->HauptmenueIpsGetFunktion.="(function($) {";
		$this->HauptmenueIpsGetFunktion.="\n";
		$this->HauptmenueIpsGetFunktion.="$.fn.ips".$textVar."= function(homesite) {";
		$this->HauptmenueIpsGetFunktion.="\n";
		$this->HauptmenueIpsGetFunktion.= $Start->toIpsGetFunktion();
		$this->HauptmenueIpsGetFunktion.="}";
		$this->HauptmenueIpsGetFunktion.="\n";
		$this->HauptmenueIpsGetFunktion.="})(jQuery);";
		$this->HauptmenueIpsGetFunktion.="\n";
	 return utf8_encode($this->HauptmenueIpsGetFunktion);
	}
	public function toHauptmenueIpsSetFunktion($Start){
		$textVar = $Start->getName().$Start->getID();
		$textVar = Utility::umlaute_ersetzen(utf8_encode($textVar));
		$this->HauptmenueIpsSetFunktion.= $Start->toIpsSetFunktion();
	 return utf8_encode($this->HauptmenueIpsSetFunktion);
	}

	public function toSliderAufruf($Start){
		$KatArray = $Start->getKategorieArray();
	 foreach ($KatArray as $object ){
	 	$this->SliderAufrufScript.= $object->toSliderAufruf();
	 	$this->toSliderAufruf($object);
	 }
	 return utf8_encode($this->SliderAufrufScript);
	}
	public function toIpsSwitchFunktion($Start){
		$KatArray = $Start->getKategorieArray();
	 foreach ($KatArray as $object ){
	 	$this->IpsSwitchFunktion.= $object->toIpsSwitchFunktion();
	 	$this->toIpsSwitchFunktion($object);
	 }
	 return utf8_encode($this->IpsSwitchFunktion);
	}

	public function toHauptmenueIpsSwitchFunktion($Start){
		$textVar = $Start->getName().$Start->getID();
		$textVar = Utility::umlaute_ersetzen(utf8_encode($textVar));
		$this->HauptmenueIpsFunktion.="(function($) {";
		$this->HauptmenueIpsFunktion.="\n";
		$this->HauptmenueIpsFunktion.="$.fn.ips".$textVar."= function(homesite) {";
		$this->HauptmenueIpsFunktion.="\n";
		$this->HauptmenueIpsFunktion.= $Start->toIpsFunktion();
		$this->HauptmenueIpsFunktion.="}";
		$this->HauptmenueIpsFunktion.="\n";
		$this->HauptmenueIpsFunktion.="})(jQuery);";
		$this->HauptmenueIpsFunktion.="\n";
	 return utf8_encode($this->HauptmenueIpsFunktion);
	}

	public function toIpsSwitchAufruf($Start){
		$KatArray = $Start->getKategorieArray();
	 foreach ($KatArray as $object ){
	 	$this->IpsSwitchAufruf.= $object->toIpsSwitchAufruf();
	 	$this->toIpsSwitchAufruf($object);
	 }
	 return utf8_encode($this->IpsSwitchAufruf);
	}

	public function toSwitchBooleanFunktion($Start){
		$KatArray = $Start->getKategorieArray();
	 foreach ($KatArray as $object ){
	 	$this->SwitchBooleanScript.= $object->toSwitchBooleanFunktion();
	 	$this->toSwitchBooleanFunktion($object);
	 }
	 return utf8_encode($this->SwitchBooleanScript);
	}

	public function toIpsSwitchBoolean($Start){
		$KatArray = $Start->getKategorieArray();
	 foreach ($KatArray as $object ){
	 	$this->IpsSwitchBooleanScript.= $object->toIpsSwitchBoolean();
	 	$this->toIpsSwitchBoolean($object);
	 }
	 return utf8_encode($this->IpsSwitchBooleanScript);
	}

	public function toGraphAufruf($Start){
		$KatArray = $Start->getKategorieArray();
	 foreach ($KatArray as $object ){
	 	$this->GraphAufruf.= $object->toGraphAufruf();
	 	$this->toGraphAufruf($object);
	 }
	 return utf8_encode($this->GraphAufruf);
	}

	public function toHtmlScriptStarten($Start){
		$KatArray = $Start->getKategorieArray();
	 foreach ($KatArray as $object ){
	 	$this->HtmlScriptStartenScript.= $object->toHtmlScriptStarten();
	 	$this->toHtmlScriptStarten($object);
	 }
	 return utf8_encode($this->HtmlScriptStartenScript);
	}

	public function toIpsScriptStarten($Start){
		$KatArray = $Start->getKategorieArray();
	 foreach ($KatArray as $object ){
	 	$this->IpsScriptStartenScript.= $object->toIpsScriptStarten();
	 	$this->toIpsScriptStarten($object);
	 }
	 return utf8_encode($this->IpsScriptStartenScript);
	}

	public function toHauptmenueIpsSwitchAufruf($Start){
		$textVar = $Start->getName().$Start->getID();
		$textVar = Utility::umlaute_ersetzen(utf8_encode($textVar));
		$this->HauptmenueIpsAufruf.="(function($) {";
		$this->HauptmenueIpsAufruf.="\n";
		$this->HauptmenueIpsAufruf.="$.fn.ips".$textVar."= function(homesite) {";
		$this->HauptmenueIpsAufruf.="\n";
		$this->HauptmenueIpsAufruf.= $Start->toIpsSwitchAufruf();
		$this->HauptmenueIpsAufruf.="}";
		$this->HauptmenueIpsAufruf.="\n";
		$this->HauptmenueIpsAufruf.="})(jQuery);";
		$this->HauptmenueIpsAufruf.="\n";
	 return utf8_encode($this->HauptmenueIpsAufruf);
	}
	public function toGraphScriptAufruf(){
		$this->GraphScript.="$('#graphpage').live('pageshow', function() {";
		$this->GraphScript.="\n";
		$this->GraphScript.="var ajaxDataRenderer = function(url, plot, options) {";
		$this->GraphScript.="\n";
		$this->GraphScript.="var ret = null;";
		$this->GraphScript.="\n";
		$this->GraphScript.=" $.ajax({async: false,url: url,dataType:'json',success: function(data) { ret  = data;}});";
		$this->GraphScript.="\n";
		$this->GraphScript.="return ret;";
		$this->GraphScript.="\n";
		$this->GraphScript.=" };";
		$this->GraphScript.="\n";
		$this->GraphScript.=" $.jqplot('chart1', sessionStorage.datei,{title: sessionStorage.ueberschrift,dataRenderer: ajaxDataRenderer,dataRendererOptions: {unusedOptionalUrl: sessionStorage.datei}});";
		$this->GraphScript.="\n";
		$this->GraphScript.="});";
		$this->GraphScript.="\n";
		return utf8_encode($this->GraphScript);
	}
	//rekursive den IPS-Baum auslesen
	public function baumAuslesen(){
		$html="";
		global $ObjektListe;
		// Quelle auslesen
		$Quellobjekt = IPS_GetObject($this->getQuelle());
		if ($Quellobjekt['ObjectType'] == 0) {
			if($Quellobjekt['ObjectIsHidden']== false){
				$kategorie = new Kategorie();
				$kategorie->setName($Quellobjekt['ObjectName']);
				$kategorie->setId($Quellobjekt['ObjectID']);
				$kategorie->setInfo($Quellobjekt['ObjectInfo']);
				$kategorie->setIcon($Quellobjekt['ObjectIcon']);
				$kategorie->setPosition($Quellobjekt['ObjectPosition']);
				$kategorie->setHidden($Quellobjekt['ObjectIsHidden']);
				$kategorie->setParent($Quellobjekt['ParentID']);
				$this->ObjektListe->put($kategorie->getId(),$kategorie);
				if($kategorie->getParent() > 0){
					if($this->ObjektListe->get($kategorie->getParent()) instanceof Kategorie){
						$katergorietmp = $this->ObjektListe->get($kategorie->getParent());
						$katergorietmp->addKategorie($kategorie);
						//echo "Parent: ".$katergorietmp->getName()." -> ".$kategorie-> getName();
						//echo"\n";
					}elseif ($this->ObjektListe->get($kategorie->getParent()) instanceof Instanz){
						$Instanztmp = $this->ObjektListe->get($kategorie->getParent());
						$Instanztmp->addKategorie($kategorie);
						//echo "Parent: ".$Instanztmp->getName()." -> ".$kategorie-> getName();
						//echo"\n";
					}elseif ($this->ObjektListe->get($kategorie->getParent()) instanceof Variable){
						$Variabletmp = $this->ObjektListe->get($kategorie->getParent());
						$Variabletmp->addKategorie($kategorie);
						//echo "Parent: ".$Variabletmp->getName()." -> ".$kategorie-> getName();
						//echo"\n";
					}elseif ($this->ObjektListe->get($kategorie->getParent()) instanceof Script){
						$Scripttmp = $this->ObjektListe->get($kategorie->getParent());
						$Scripttmp->addKategorie($kategorie);
						//echo "Parent: ".$Scripttmp->getName()." -> ".$kategorie-> getName();
						//echo"\n";
					}elseif ($this->ObjektListe->get($kategorie->getParent()) instanceof Ereignis){
						$Ereignistmp = $this->ObjektListe->get($kategorie->getParent());
						$Ereignistmp->addKategorie($kategorie);
						//echo "Parent: ".$Ereignistmp->getName()." -> ".$kategorie-> getName();
						//echo"\n";
					}
				}
			}
		}

		if ($Quellobjekt['ObjectType'] == 1) {
			if($Quellobjekt['ObjectIsHidden']== false){
				$Instanz = new Instanz();
				$Instanz->setName($Quellobjekt['ObjectName']);
				$Instanz->setId($Quellobjekt['ObjectID']);
				$Instanz->setInfo($Quellobjekt['ObjectInfo']);
				$Instanz->setIcon($Quellobjekt['ObjectIcon']);
				$Instanz->setPosition($Quellobjekt['ObjectPosition']);
				$Instanz->setHidden($Quellobjekt['ObjectIsHidden']);
				$Instanz->setParent($Quellobjekt['ParentID']);
				$Modul = IPS_GetInstance($Quellobjekt['ObjectID']);
				$ModuleInfo = $Modul['ModuleInfo'];
				//print_r ($Modul);
				if(!empty($ModuleInfo)){
					$Instanz->setModuleName($ModuleInfo['ModuleName']);
					$Instanz->setModuleID($ModuleInfo['ModuleID']);
				}
				$this->ObjektListe->put($Instanz->getId(),$Instanz);
				if($Instanz->getParent() > 0){
					if($this->ObjektListe->get($Instanz->getParent()) instanceof Kategorie){
						$katergorietmp = $this->ObjektListe->get($Instanz->getParent());
						$katergorietmp->addInstanz($Instanz);
						//echo "Parent1: ".$katergorietmp->getName()." -> ".$Instanz-> getName();
						//echo"\n";
					}elseif ($this->ObjektListe->get($Instanz->getParent()) instanceof Instanz){
						$Instanztmp = $this->ObjektListe->get($Instanz->getParent());
						$Instanztmp->addInstanz($Instanz);
						//echo "Parent1: ".$Instanztmp->getName()." -> ".$Instanz-> getName();
						//echo"\n";
					}elseif ($this->ObjektListe->get($Instanz->getParent()) instanceof Variable){
						$Variabletmp = $this->ObjektListe->get($Instanz->getParent());
						$Variabletmp->addInstanz($Instanz);
						//echo "Parent1: ".$Variabletmp->getName()." -> ".$Instanz-> getName();
						//echo"\n";
					}elseif ($this->ObjektListe->get($Instanz->getParent()) instanceof Script){
						$Scripttmp = $this->ObjektListe->get($Instanz->getParent());
						$Scripttmp->addInstanz($Instanz);
						//echo "Parent1: ".$Scripttmp->getName()." -> ".$Instanz-> getName();
						//echo"\n";
					}elseif ($this->ObjektListe->get($Instanz->getParent()) instanceof Ereignis){
						$Ereignistmp = $this->ObjektListe->get($Instanz->getParent());
						$Scripttmp->addInstanz($Instanz);
						//echo "Parent1: ".$Scripttmp->getName()." -> ".$Instanz-> getName();
						//echo"\n";
					}
				}
			}
		}

		if ($Quellobjekt['ObjectType'] == 2) {
			if($Quellobjekt['ObjectIsHidden']== false){
				$archiveHandlerID = IPS_GetInstanceIDByName("Archive Handler", 0);
				$Variable = new Variable();
				$Variable->setName($Quellobjekt['ObjectName']);
				$Variable->setId($Quellobjekt['ObjectID']);
				$Variable->setInfo($Quellobjekt['ObjectInfo']);
				$Variable->setIcon($Quellobjekt['ObjectIcon']);
				$Variable->setPosition($Quellobjekt['ObjectPosition']);
				$Variable->setHidden($Quellobjekt['ObjectIsHidden']);
				$Variable->setParent($Quellobjekt['ParentID']);
				$QuellVariable = IPS_GetVariable($Quellobjekt['ObjectID']);
				$QuellVariableWerte = $QuellVariable['VariableValue'];
				$Variable->setValueType($QuellVariableWerte['ValueType']);
				$Variable->setValueBoolean($QuellVariableWerte['ValueBoolean']);
				$Variable->setValueInteger($QuellVariableWerte['ValueInteger']);
				$Variable->setValueFloat($QuellVariableWerte['ValueFloat']);
				$Variable->setValueString($QuellVariableWerte['ValueString']);
				if(!empty($QuellVariable['VariableProfile'])){
					$Profilname = $QuellVariable['VariableProfile'];
					//echo "VariableProfile".$Profilname;
					//echo "\n";
				}
				if(!empty($QuellVariable['VariableCustomProfile'])){
					$Profilname = $QuellVariable['VariableCustomProfile'];
					//echo "VariableCustomProfile".$Profilname;
					//echo "\n";
				}
				if(!empty($Profilname)){
					//echo $Variable->getName().":"." ".$Variable->getId();
					//echo"\n";
					/*print_r($Profilname);
					 echo"\n";*/
					$Profil = IPS_GetVariableProfile($Profilname);
					$Associations = $Profil['Associations'];
					if(!empty($Associations[0]['Name'])){
						$Variable->setEinheit($Associations[0]['Name']);
					}
					if(!empty($Associations[1]['Name'])){
						$Variable->setEinheit1($Associations[1]['Name']);
					}
					if(!empty($Associations[0]['Icon'])){
						$Variable->setIcon($Associations[0]['Icon']);
					}else{
						$Variable->setIcon($Profil['Icon']);
					}
					$Variable->setIsReadOnly($Profil['IsReadOnly']);
					$Variable->setMaxValue($Profil['MaxValue']);
					$Variable->setMinValue($Profil['MinValue']);
					$Variable->setStepSize($Profil['StepSize']);
					$Variable->setDigits($Profil['Digits']);
					$Variable->setPrefix($Profil['Prefix']);
					$Variable->setSuffix($Profil['Suffix']);
					$Variable->setProfileName($Profil['ProfileName']);
					$Variable->setProfileType($Profil['ProfileType']);
					//print_r($Profil);
					//echo"\n";
				}
				$Variable->setStatus(AC_GetLoggingStatus($archiveHandlerID, $Quellobjekt['ObjectID']));
				$this->ObjektListe->put($Variable->getId(),$Variable);
				if($Variable->getParent() > 0){
					if($this->ObjektListe->get($Variable->getParent()) instanceof Kategorie){
						$katergorietmp = $this->ObjektListe->get($Variable->getParent());
						$katergorietmp->addVariable($Variable);
						//echo "Parent2_Kategorie: ".$katergorietmp->getName()." -> ".$Variable-> getName();
						//echo"\n";
					}elseif ($this->ObjektListe->get($Variable->getParent()) instanceof Instanz){
						$Instanztmp = $this->ObjektListe->get($Variable->getParent());
						$Instanztmp->addVariable($Variable);
						//echo "Parent2_Instanz: ".$Instanztmp->getName()." -> ".$Variable-> getName();
						//echo"\n";
					}elseif ($this->ObjektListe->get($Variable->getParent()) instanceof Variable){
						$Variabletmp = $this->ObjektListe->get($Variable->getParent());
						$Variabletmp->addVariable($Variable);
						//echo "Parent2_Variable: ".$Variabletmp->getName()." -> ".$Variable-> getName();
						//echo"\n";
					}elseif ($this->ObjektListe->get($Variable->getParent()) instanceof Script){
						$Scripttmp = $this->ObjektListe->get($Variable->getParent());
						$Scripttmp->addVariable($Variable);
						//echo "Parent2: ".$Scripttmp->getName()." -> ".$Variable-> getName();
						//echo"\n";
					}elseif ($this->ObjektListe->get($Variable->getParent()) instanceof Ereignis){
						$Ereignistmp = $this->ObjektListe->get($Variable->getParent());
						$Ereignistmp->addVariable($Variable);
						//echo "Parent2: ".$Ereignistmp->getName()." -> ".$Variable-> getName();
						//echo"\n";
					}
				}
			}
		}

		if ($Quellobjekt['ObjectType'] == 3) {
			if($Quellobjekt['ObjectIsHidden']== false){
				$Script = new Script();
				$Script->setName($Quellobjekt['ObjectName']);
				$Script->setId($Quellobjekt['ObjectID']);
				$Script->setInfo($Quellobjekt['ObjectInfo']);
				$Script->setIcon($Quellobjekt['ObjectIcon']);
				$Script->setPosition($Quellobjekt['ObjectPosition']);
				$Script->setHidden($Quellobjekt['ObjectIsHidden']);
				$Script->setParent($Quellobjekt['ParentID']);
				$this->ObjektListe->put($Script->getId(),$Script);
				if($Script->getParent() > 0){
					if($this->ObjektListe->get($Script->getParent()) instanceof Kategorie){
						$katergorietmp = $this->ObjektListe->get($Script->getParent());
						$katergorietmp->addScript($Script);
						//echo "Parent3: ".$katergorietmp->getName()." -> ".$Script-> getName();
						//echo"\n";
					}elseif ($this->ObjektListe->get($Script->getParent()) instanceof Instanz){
						$Instanztmp = $this->ObjektListe->get($Script->getParent());
						$Instanztmp->addScript($Script);
						//echo "Parent3: ".$Instanztmp->getName()." -> ".$Script-> getName();
						//echo"\n";
					}elseif ($this->ObjektListe->get($Script->getParent()) instanceof Variable){
						$Variabletmp = $this->ObjektListe->get($Script->getParent());
						$Variabletmp->addScript($Script);
						//echo "Parent3: ".$Variabletmp->getName()." -> ".$Script-> getName();
						//echo"\n";
					}elseif ($this->ObjektListe->get($Script->getParent()) instanceof Script){
						$Scripttmp = $this->ObjektListe->get($Script->getParent());
						$Scripttmp->addScript($Script);
						//echo "Parent3: ".$Scripttmp->getName()." -> ".$Script-> getName();
						//echo"\n";
					}elseif ($this->ObjektListe->get($Script->getParent()) instanceof Ereignis){
						$Ereignistmp = $this->ObjektListe->get($Script->getParent());
						$Ereignistmp->addScript($Script);
						//echo "Parent3: ".$Ereignistmp->getName()." -> ".$Script-> getName();
						//echo"\n";
					}
				}
			}
		}

		if ($Quellobjekt['ObjectType'] == 4) {
			if($Quellobjekt['ObjectIsHidden']== false){
				$Ereignis = new Ereignis();
				$Name = $Quellobjekt['ObjectName'];
				$ID = $Quellobjekt['ObjectID'];
				$Ereignis->setName($Quellobjekt['ObjectName']);
				$Ereignis->setId($Quellobjekt['ObjectID']);
				$Ereignis->setInfo($Quellobjekt['ObjectInfo']);
				$Ereignis->setIcon($Quellobjekt['ObjectIcon']);
				$Ereignis->setPosition($Quellobjekt['ObjectPosition']);
				$Ereignis->setHidden($Quellobjekt['ObjectIsHidden']);
				$Ereignis->setParent($Quellobjekt['ParentID']);
				$this->ObjektListe->put($Ereignis->getId(),$Ereignis);
				if($Ereignis->getParent() > 0){
					if($this->ObjektListe->get($Ereignis->getParent()) instanceof Kategorie){
						$katergorietmp = $this->ObjektListe->get($Ereignis->getParent());
						$katergorietmp->addEreignis($Ereignis);
						//echo "Parent4: ".$katergorietmp->getName()." -> ".$Ereignis-> getName();
						//echo"\n";
					}elseif ($this->ObjektListe->get($Ereignis->getParent()) instanceof Instanz){
						$Instanztmp = $this->ObjektListe->get($Ereignis->getParent());
						$Instanztmp->addEreignis($Ereignis);
						//echo "Parent4: ".$Instanztmp->getName()." -> ".$Ereignis-> getName();
						//echo"\n";
					}elseif ($this->ObjektListe->get($Ereignis->getParent()) instanceof Variable){
						$Variabletmp = $this->ObjektListe->get($Ereignis->getParent());
						$Variabletmp->addEreignis($Ereignis);
						//echo "Parent4: ".$Variabletmp->getName()." -> ".$Ereignis-> getName();
						//echo"\n";
					}elseif ($this->ObjektListe->get($Ereignis->getParent()) instanceof Script){
						$Scripttmp = $this->ObjektListe->get($Ereignis->getParent());
						$Scripttmp->addEreignis($Ereignis);
						//echo "Parent4: ".$Scripttmp->getName()." -> ".$Ereignis-> getName();
						//echo"\n";
					}elseif ($this->ObjektListe->get($Ereignis->getParent()) instanceof Ereignis){
						$Ereignistmp = $this->ObjektListe->get($Ereignis->getParent());
						$Ereignistmp->addEreignis($Ereignis);
						//echo "Parent4: ".$Ereignistmp->getName()." -> ".$Ereignis-> getName();
						//echo"\n";
					}
				}
			}
		}
		$kinder = $Quellobjekt['ChildrenIDs'];
		foreach ($kinder as $child ){
			$this->setQuelle($child);
			//$merker = $NeuesObjekt;
			$this->baumAuslesen();
		}
		return $this->ObjektListe;
	}
	public function getQuelle() {
		return $this->Quelle;
	}
	public function setQuelle($Quelle) {
		$this->Quelle = $Quelle;
	}
}
?>