<?php

/**
 * Description of Script
 * Diese Klasse gibt die Scripte des IPS-Systems in Html und Java-Script aus
 * @author Dirk Kruck
 */
class Script {
	private $ListeKategorien = array();
	private $ListeInstanzen = array();
	private $ListeVariablen = array();
	private $ListeEreignisse = array();
	private $ListeScripte = array();
	private $Id = null;
	private $Name = null;
	private $Parent = null;
	private $Icon = null;
	private $Info = null;
	private $Position = null;
	private $Hidden = null;
	private $ArrayKategorienObject = null;
	private $ArrayInstanzenObject = null;
	private $ArrayVariablenObject = null;
	private $ArrayEreignisseObject = null;
	private $ArrayScripteObject = null;
	private $HtmlSeiten = "";
	private $ScriptStartenScript = "";

	public function __construct(){
		$this->ArrayKategorienObject = new ArrayObject($this->ListeKategorien);
		$this->ArrayInstanzenObject = new ArrayObject($this->ListeInstanzen);
		$this->ArrayVariablenObject = new ArrayObject($this->ListeVariablen);
		$this->ArrayEreignisseObject = new ArrayObject($this->ListeEreignisse);
		$this->ArrayScripteObject = new ArrayObject($this->ListeScripte);
	}
	// Gibt den Namen des Script zurck
	public function getName() {
		return $this->Name;
	}
	// Setzt den Namen des Script
	public function setName($Name) {
		$this->Name = $Name;
	}
	// Gibt die Objektnummer des Script zurck
	public function getId(){
		return $this->Id;
	}
	// Setzt die Objektnummer des Script
	public function setId($Id) {
		$this->Id = $Id;
	}
	// Gibt den Iconname des Script zurck
	public function getIcon(){
		return $this->Icon;
	}
	// Setzt den Iconname des Script
	public function setIcon($Icon) {
		$this->Icon = $Icon;
	}
	// Gibt die Info des Script zurck
	public function getInfo(){
		return $this->Info;
	}
	// Setzt die Info des Script
	public function setInfo($Info) {
		$this->Info = $Info;
	}
	// Gibt die Objektnummer des Parentobjekt des Script zurck
	public function getParent(){
		return $this->Parent;
	}
	// Setzt die Objektnummer des Parentobjekt des Script
	public function setParent($Parent) {
		$this->Parent = $Parent;
	}
	// Gibt die Position(Reihenfolge) des Script zurck
	public function getPosition(){
		return $this->Position;
	}
	// Setzt die Position(Reihenfolge) des Script
	public function setPosition($Position) {
		$this->Position = $Position;
	}
	// Gibtt den Status der Sichtbarkeit des Script zurck
	public function getHidden(){
		return $this->Hidden;
	}
	// Setzt den Status der Sichtbarkeit der Instanz
	public function setHidden($Hidden) {
		$this->Hidden = $Hidden;
	}
	// Kategorieobjekt in Liste einfgen
	public function addKategorie($Kategorie)
	{
		$this->ArrayKategorienObject->append($Kategorie);
	}
	// Instanzobjekt in Liste einfgen
	public function addInstanz($Instanz)
	{
		$this->ArrayInstanzenObject->append($Instanz);
	}
	// Variableobjekt in Liste einfgen
	public function addVariable($Variable)
	{
		$this->ArrayVariablenObject->append($Variable);
	}
	// Ereignisobjekt in Liste einfgen
	public function addEreignis($Ereignis)
	{
		$this->ArrayEreignisseObject->append($Ereignis);
	}
	// Instanzobjekt in Liste einfgen
	public function addScript($Script)
	{
		$this->ArrayScripteObject->append($Script);
	}
	//Gibt die Liste der Kategorien zurck
	public function getKategorieArray(){
		return $this->ArrayKategorienObject;
	}
	//Gibt die Liste der Instanzen zurck
	public function getInstanzArray(){
		return $this->ArrayInstanzenObject;
	}
	//Gibt die Liste der Variablen zurck
	public function getVariableArray(){
		return $this->ArrayVariablenObject;
	}
	//Gibt die Liste der Ereignisse zurck
	public function getEreignisArray(){
		return $this->ArrayEreignisseObject;
	}
	//Gibt die Liste der Scripte zurck
	public function getScriptArray(){
		return $this->ArrayScripteObject;
	}
	// Schreibt die Html-Zeile fr den Script
	public function toScriptHtml() {
		$textVar = $this->getName().$this->getID();
		$textVar = Utility::umlaute_ersetzen(utf8_encode($textVar));
		$this->HtmlSeiten.="<li><span>".$this->getName()."</span><span class='scriptbutton'><a href='#' data-role='button' data-icon='script' id='".$textVar."Button' data-iconpos='notext' data-transition='pop'></a>"."</span></li>";
		$this->HtmlSeiten.="\n";
		foreach ($this->getEreignisArray() as $ereignis){
			$this->HtmlSeiten.=$ereignis->toEreignisHtml();
		}
		return $this->HtmlSeiten;
	}
	// Schreibt den Java-Script fr den Script-Aufruf
	public function toHtmlScriptStarten() {
		$textVar = $this->getName().$this->getID()."Button";
		$textVar = Utility::umlaute_ersetzen(utf8_encode($textVar));
		$this->ScriptStartenScript.="$('#".$textVar."').live('click', function() {";
		$this->ScriptStartenScript.="\n";
		$this->ScriptStartenScript.="$('#".$textVar."').ips".$textVar."($('#".$textVar."'));";
		$this->ScriptStartenScript.="\n";
		$this->ScriptStartenScript.="});";
		$this->ScriptStartenScript.="\n";
		return $this->ScriptStartenScript;
	}
	// Schreibt den Java-Script fr den Script um die rpc-Schnittstelle aufzurufen
	public function toIpsScriptStarten() {
		$textVar = $this->getName().$this->getID()."Button";
		$textVar = Utility::umlaute_ersetzen(utf8_encode($textVar));
		$ValueT ="'"."IPS_RunScript"."'";
		$ValueID = "'".$this->getID()."'";
		$this->IpsScriptStartenScript.="(function($) {";
		$this->IpsScriptStartenScript.="\n";
		$this->IpsScriptStartenScript.="$.fn.ips".$textVar."= function(homesite) {";
		$this->IpsScriptStartenScript.="\n";
		$this->IpsScriptStartenScript.="state = $(homesite).val();";
		$this->IpsScriptStartenScript.="\n";
		$this->IpsScriptStartenScript.="homesite."."ipsscript"."('2.0','0',".$ValueT.",".$ValueID.","."'#".$textVar."'".");";
		$this->IpsScriptStartenScript.="\n";
		$this->IpsScriptStartenScript.="}";
		$this->IpsScriptStartenScript.="\n";
		$this->IpsScriptStartenScript.="})(jQuery);";
		$this->IpsScriptStartenScript.="\n";
		return $this->IpsScriptStartenScript;
	}
}
?>
