<?php

/**
 * Description of Variable
 * Diese Klasse gibt die Variablen des IPS-Systems in Html und Java-Script aus
 * @author Dirk Kruck
 */
class Variable {
	private $ListeKategorien = array();
	private $ListeInstanzen = array();
	private $ListeVariablen = array();
	private $ListeEreignisse = array();
	private $ListeScripte = array();
	private $Id = null;
	private $Name = null;
	private $Parent = null;
	private $Icon = null;
	private $Info = null;
	private $Position = null;
	private $Hidden = null;
	private $Status =null;
	private $Digits = null;
	private $IsReadOnly = null;
	private $ValueType = null;
	private $ValueBoolean = null;
	private $ValueInteger = null;
	private $ValueFloat = null;
	private $ValueString = null;
	private $MaxValue = null;
	private $MinValue = null;
	private $Prefix = null;
	private $ProfileName = null;
	private $ProfileType = null;
	private $StepSize = null;
	private $Suffix = null;
	private $Einheit = null;
	private $Einheit1 = null;
	private $ArrayKategorienObject = null;
	private $ArrayInstanzenObject = null;
	private $ArrayVariablenObject = null;
	private $ArrayEreignisseObject = null;
	private $ArrayScripteObject = null;
	private $HtmlSeiten = "";
	private $IpsGetScript = "";
	private $IpsSetScript = "";
	private $IpsSwitchScript = "";
	private $IpsSwitchAufruf = "";
	private $GraphAufruf = "";
	private $SwitchBooleanScript = "";
	private $IpsSwitchBooleanScript = "";
	private $SliderAufrufScript = "";

	public function __construct(){
		$this->ArrayKategorienObject = new ArrayObject($this->ListeKategorien);
		$this->ArrayInstanzenObject = new ArrayObject($this->ListeInstanzen);
		$this->ArrayVariablenObject = new ArrayObject($this->ListeVariablen);
		$this->ArrayEreignisseObject = new ArrayObject($this->ListeEreignisse);
		$this->ArrayScripteObject = new ArrayObject($this->ListeScripte);
	}
	// Gibtt den Namen der Variable zurck
	public function getName() {
		return $this->Name;
	}
	// Setzt den Namen der Variable
	public function setName($Name) {
		$this->Name = $Name;
	}
	// Gibtt die Objektnummer der Variable zurck
	public function getId(){
		return $this->Id;
	}
	// Setzt die Objektnummer der Variable
	public function setId($Id) {
		$this->Id = $Id;
	}
	// Gibt den Iconname der Variable zurck
	public function getIcon(){
		return $this->Icon;
	}
	// Setzt den Iconname der Variable
	public function setIcon($Icon) {
		$this->Icon = $Icon;
	}
	// Setzt die Info der Variable
	public function setInfo($Info) {
		$this->Info = $Info;
	}
	// Gibt die Info der Variable zurck
	public function getInfo(){
		return $this->Info;
	}
	// Gibt die Objektnummer des Parentobjekt der Variable zurck
	public function getParent(){
		return $this->Parent;
	}
	// Setzt die Objektnummer des Parentobjekt der Variable
	public function setParent($Parent) {
		$this->Parent = $Parent;
	}
	// Gibt die Position(Reihenfolge) der Variable zurck
	public function getPosition(){
		return $this->Position;
	}
	// Setzt die Position(Reihenfolge) der Variable
	public function setPosition($Position) {
		$this->Position = $Position;
	}
	// Gibt den Status der Sichtbarkeit der Variable zurck
	public function getHidden(){
		return $this->Hidden;
	}
	// Setzt den Status der Sichtbarkeit der Variable
	public function setHidden($Hidden) {
		$this->Hidden = $Hidden;
	}
	// Gibt den Status der Variable zurck
	public function getStatus(){
		return $this->Status;
	}
	// Setzt den Status der Variable
	public function setStatus($Status) {
		$this->Status = $Status;
	}
	// Gibt die Anzahl der Nachkommastellen der Variable zurck
	public function getDigits(){
		return $this->Digits;
	}
	// Setzt die Anzahl der Nachkommastellen der Variable
	public function setDigits($Digits) {
		$this->Digits = $Digits;
	}
	// Gibt TRUE, wenn es ein systemerstelltes Profil ist, welches nicht gendert werden kann
	public function getIsReadOnly(){
		return $this->IsReadOnly;
	}
	// Setzt ein systemerstelltes Profil der Variable
	public function setIsReadOnly($IsReadOnly) {
		$this->IsReadOnly = $IsReadOnly;
	}
	// Gibt den Maxwert der Variable zurck
	public function getMaxValue(){
		return $this->MaxValue;
	}
	// Setzt den Maxwert der Variable
	public function setMaxValue($MaxValue) {
		$this->MaxValue = $MaxValue;
	}
	// Gibt den Minwert der Variable zurck
	public function getMinValue(){
		return $this->MinValue;
	}
	// Setzt den Minwert der Variable
	public function setMinValue($MinValue) {
		$this->MinValue = $MinValue;
	}
	// Gibt den Prfix fr die Visualisierung der Variable zurck
	public function getPrefix(){
		return $this->Prefix;
	}
	// Setzt den Prfix fr die Visualisierung der Variable
	public function setPrefix($Prefix) {
		$this->Prefix = $Prefix;
	}
	// Gibt den Name des Profils der Variable zurck
	public function getProfileName(){
		return $this->ProfileName;
	}
	// Setzt den Name des Profils der Variable
	public function setProfileName($ProfileName) {
		$this->ProfileName = $ProfileName;
	}
	// Gibt den Type des Profils der Variable zurck
	public function getProfileType(){
		return $this->ProfileType;
	}
	// Setzt den Type des Profils der Variable
	public function setProfileType($ProfileType) {
		$this->ProfileType = $ProfileType;
	}
	// Gibt die Schrittweite fr die Visualisierung; 0, wenn Assoziationstabelle genutzt werden soll der Variable zurck
	public function getStepSize(){
		return $this->StepSize;
	}
	// Setzt die Schrittweite fr die Visualisierung; 0, wenn Assoziationstabelle genutzt werden soll der Variable
	public function setStepSize($StepSize) {
		$this->StepSize = $StepSize;
	}
	// Gibt den Suffix fr die Visualisierung der Variable zurck
	public function getSuffix(){
		return $this->Suffix;
	}
	// Setzt den Suffix fr die Visualisierung der Variable
	public function setSuffix($Suffix) {
		$this->Suffix = $Suffix;
	}
	// Gibt den ValueType(z.B. Boolean,Integer,usw.) der Variable zurck
	public function getValueType(){
		return $this->ValueType;
	}
	// Setzt den ValueType(z.B. Boolean,Integer,usw.) der Variable
	public function setValueType($ValueType) {
		$this->ValueType = $ValueType;
	}
	// Gibt den Wert (true oder false) der Variable zurck
	public function getValueBoolean(){
		return $this->ValueBoolean;
	}
	// Setzt den Wert (true oder false) der Variable
	public function setValueBoolean($ValueBoolean) {
		$this->ValueBoolean = $ValueBoolean;
	}
	// Gibt den Wert (z.B. 1,2,3,4....) der Variable zurck
	public function getValueInteger(){
		return $this->ValueInteger;
	}
	// Setzt den Wert (z.B. 1,2,3,4....) der Variable
	public function setValueInteger($ValueInteger) {
		$this->ValueInteger = $ValueInteger;
	}
	// Gibt den Wert (z.B. 1.234,2.5,3.8,4.5....) der Variable zurck
	public function getValueFloat(){
		return $this->ValueFloat;
	}
	// Setzt den Wert (z.B. 1.234,2.5,3.8,4.5....) der Variable
	public function setValueFloat($ValueFloat) {
		$this->ValueFloat = $ValueFloat;
	}
	// Gibt den Wert (z.B. Wohnung,Wohnzimmer....) der Variable zurck
	public function getValueString(){
		return $this->ValueString;
	}
	// Setzt den Wert (z.B. Wohnung,Wohnzimmer....) der Variable
	public function setValueString($ValueString) {
		$this->ValueString = $ValueString;
	}
	// Gibt den Wert fr die Einheit (z.B. c,%,....) der Variable zurck
	public function getEinheit(){
		return $this->Einheit;
	}
	// Setzt den Wert fr die Einheit (z.B. c,%,....) der Variable
	public function setEinheit($Einheit) {
		$this->Einheit = $Einheit;
	}
	// Gibt den Wert fr die Einheit1 (z.B. c,%,....) der Variable zurck
	public function getEinheit1(){
		return $this->Einheit1;
	}
	// Setzt den Wert fr die Einheit (z.B. c,%,....) der Variable
	public function setEinheit1($Einheit1) {
		$this->Einheit1 = $Einheit1;
	}
	// Kategorieobjekt in Liste einfgen
	public function addKategorie($Kategorie)
	{
		$this->ArrayKategorienObject->append($Kategorie);
	}
	// Instanzobjekt in Liste einfgen
	public function addInstanz($Instanz)
	{
		$this->ArrayInstanzenObject->append($Instanz);
	}
	// Variableobjekt in Liste einfgen
	public function addVariable($Variable)
	{
		$this->ArrayVariablenObject->append($Variable);
	}
	// Ereignisobjekt in Liste einfgen
	public function addEreignis($Ereignis)
	{
		$this->ArrayEreignisseObject->append($Ereignis);
	}
	// Scriptobjekt in Liste einfgen
	public function addScript($Script)
	{
		$this->ArrayScripteObject->append($Script);
	}
	//Gibt die Liste der Kategorien zurck
	public function getKategorieArray(){
		return $this->ArrayKategorienObject;
	}
	//Gibt die Liste der Instanzen zurck
	public function getInstanzArray(){
		return $this->ArrayInstanzenObject;
	}
	//Gibt die Liste der Variablen zurck
	public function getVariableArray(){
		return $this->ArrayVariablenObject;
	}
	//Gibt die Liste der Ereignisse zurck
	public function getEreignisArray(){
		return $this->ArrayEreignisseObject;
	}
	//Gibt die Liste der Scripte zurck
	public function getScriptArray(){
		return $this->ArrayScripteObject;
	}
	//Schreibt den Html-Code fr Schalter und Slider der Variable
	public function toVariableHtml() {
		$textVar = $this->getName().$this->getID();
		$textVar = Utility::umlaute_ersetzen(utf8_encode($textVar));
		$String = $this->getProfileName();
		if(stristr($String, 'Switch')){
			//echo "schalter:".$this->getID();
			$this->HtmlSeiten.="<li class='containing-element'>";
			if($this->getStatus()){
				$this->HtmlSeiten.="<img src='icons/".$this->getIcon().".png'"." align='left'><label for='".$textVar."'><span class='anzeige'>".$this->getName()."</span><span class='anzeige2'><a href='#' data-role='button' data-icon='graph' id='".$textVar."Button' data-iconpos='notext' data-transition='pop'></a>"."</span></label>";
			}else{
				$this->HtmlSeiten.="<img src='icons/".$this->getIcon().".png'"." align='left'><label for='".$textVar."'><span class='anzeige'>".$this->getName()."</span></label>";
			}
			$this->HtmlSeiten.="<select name='".$this->getName().$this->getID()."'"." id='".$textVar."'"." data-role='slider'>";
			$this->HtmlSeiten.="<option value='off'>".$this->getEinheit()."</option>";
			$this->HtmlSeiten.="<option value='on'>".$this->getEinheit1()."</option>";
			$this->HtmlSeiten.="</select>";
			$this->HtmlSeiten.="</li>";
			$this->HtmlSeiten.="\n";
		}elseif(stristr($String, 'FHT.Temperatur')) {
			$this->HtmlSeiten.="<li class='containing-element'>";
			$this->HtmlSeiten.="<img src='icons/".$this->getIcon().".png'"." align='left'>";
			$this->HtmlSeiten.="<label for='".$textVar."'><span class='anzeige'>".$this->getName()."</span></label>";
			$this->HtmlSeiten.="<input type='range' name="."'".$this->getName()."'"." id="."'".$textVar."'". "value="."'".$this->getMinValue()."'"." min="."'".$this->getMinValue()."'"." max="."'".$this->getMaxValue()."'"." step='0.5' data-highlight='true' data-mini='true' />";
			$this->HtmlSeiten.="</li>";
			$this->HtmlSeiten.="\n";
		}else{
			if($this->getStatus()){
				$this->HtmlSeiten.="<li><img src='icons/".$this->getIcon().".png'"." align='left'><span class='anzeige'>".$this->getName()."</span><span class='anzeige1'><a href='#' data-role='button' data-icon='graph' id='".$textVar."Button' data-iconpos='notext' data-transition='pop'></a>"."</span><span class='wert' id='".$textVar."'>".$this->getSuffix()."</span></li>";
				$this->HtmlSeiten.="\n";
			}
			else{
				$einheit = $this->getSuffix();
				$this->HtmlSeiten.="<li><img src='icons/".$this->getIcon().".png'"." align='left'><span class='anzeige'>".$this->getName()."</span><span class='wert' id='".$textVar."'>".$einheit."</span></li>";
				$this->HtmlSeiten.="\n";
			}
		}
		foreach ($this->getScriptArray() as $script){
			$this->HtmlSeiten.=$script->toScriptHtml();
		}
		return $this->HtmlSeiten;
	}
	// Schreibt den Java-Script fr alle Typen Getter(Boolean,Integer,String,usw.) der Variable
	public function toIpsGetFunktion() {
		$textVar = $this->getName().$this->getID();
		$textVar = Utility::umlaute_ersetzen(utf8_encode($textVar));
		$Einheit =	$this->getEinheit();
		$Einheit1 =	$this->getEinheit1();
		$String = $this->getProfileName();
		if($this->getValueType()==0){
			$ValueT ="'"."GetValueBoolean"."'";
			$funktion ="boolean";
			if(empty($Einheit) and empty($Einheit1)){
				$Einheit =	$this->getSuffix();
			}
		}elseif($this->getValueType()==1){
			$ValueT ="'"."GetValueInteger"."'";
			$funktion ="integer";
			if(empty($Einheit) and empty($Einheit1)){
				$Einheit =	$this->getSuffix();
			}
		}elseif($this->getValueType()==2){
			$ValueT ="'"."GetValueFloat"."'";
			$funktion ="float";
			if(empty($Einheit) and empty($Einheit1)){
				$Einheit =	$this->getSuffix();
				if($Einheit == "Aus"){
					$Einheit = "C";
				}
			}
		}elseif($this->getValueType()==3){
			$ValueT ="'"."GetValueString"."'";
			$funktion ="string";
			if(empty($Einheit) and empty($Einheit1)){
				$Einheit =	$this->getSuffix();
			}
		}
		if(!stristr($String, 'Switch') && !stristr($String, 'FHT.Temperatur') ){
			$typ = 1;	// Anzeige
			$ValueID = "'".$this->getID()."'";
			if($this->getValueType()==2 && (stristr($Einheit, 'Aus') ||stristr($Einheit, 'An'))){
				$Einheit="C";
			}
			$this->IpsGetScript.="homesite."."ips".$funktion."('2.0','0',".$ValueT.",".$ValueID.",".$typ.","."'#".$textVar."'".","."'".$Einheit."',"."'".$Einheit1."');";
			$this->IpsGetScript.="\n";
			return $this->IpsGetScript;
		}elseif(stristr($String, 'Switch')){
			$funktion ="booleansw";
			$ValueID = "'".$this->getID()."'";
			$this->IpsGetScript.="homesite."."ips".$funktion."('2.0','0',".$ValueT.",".$ValueID.","."'#".$textVar."'".","."'".$Einheit."',"."'".$Einheit1."');";
			$this->IpsGetScript.="\n";
			return $this->IpsGetScript;
		}elseif(stristr($String, 'FHT.Temperatur')){
			$typ = 2; //Slider
			$EigeneEinheit = "C";
			$ValueID = "'".$this->getID()."'";
			$this->IpsGetScript.="homesite."."ips".$funktion."('2.0','0',".$ValueT.",".$ValueID.",".$typ.","."'#".$textVar."'".","."'".$EigeneEinheit."',"."'".$Einheit1."');";
			$this->IpsGetScript.="\n";
			return $this->IpsGetScript;
		}
	}
	// Schreibt den Java-Script fr alle Typen Setter(Boolean,Integer,String,usw.) der Variable
	public function toIpsSetFunktion() {
		$textVar = $this->getName().$this->getID();
		$textVar = Utility::umlaute_ersetzen(utf8_encode($textVar));
		$String = $this->getProfileName();
		$ValueID = "'".$this->getID()."'";
		if($this->getValueType()==0){
			$ValueT ="'"."SetValueBoolean"."'";
			$funktion ="boolean";
			if(empty($Einheit) and empty($Einheit1)){
				$Einheit =	$this->getSuffix();
			}
		}elseif($this->getValueType()==1){
			$ValueT ="'"."SetValueInteger"."'";
			$funktion ="integer";
			if(empty($Einheit) and empty($Einheit1)){
				$Einheit =	$this->getSuffix();
			}
		}elseif($this->getValueType()==2){
			$ValueT ="'"."SetValueFloat"."'";
			$funktion ="float";
			if(empty($Einheit) and empty($Einheit1)){
				$Einheit =	$this->getSuffix();
				if($Einheit == "Aus"){
					$Einheit = "C";
				}
			}
		}elseif($this->getValueType()==3){
			$ValueT ="'"."SetValueString"."'";
			$funktion ="string";
			if(empty($Einheit) and empty($Einheit1)){
				$Einheit =	$this->getSuffix();
			}
		}
		$this->IpsSetScript.="(function($) {";
		$this->IpsSetScript.="\n";
		$this->IpsSetScript.="$.fn.ipsSet".$textVar."= function(homesite) {";
		$this->IpsSetScript.="\n";
		$this->IpsSetScript.="Wert = $(homesite).val();";
		$this->IpsSetScript.="\n";
		$this->IpsSetScript.="homesite."."ipsset"."('2.0','0',".$ValueT.",".$ValueID.","."'#".$textVar."'".","."Wert".");";
		$this->IpsSetScript.="\n";
		$this->IpsSetScript.="}";
		$this->IpsSetScript.="\n";
		$this->IpsSetScript.="})(jQuery);";
		$this->IpsSetScript.="\n";
		return $this->IpsSetScript;
	}
	// Schreibt den Java-Script fr Switch(Schalter) der Variable
	public function toSwitchBooleanFunktion(){
		if($this->getProfileName()=="~Switch"){
			$textVar = $this->getName().$this->getID();
			$textVar = Utility::umlaute_ersetzen(utf8_encode($textVar));
			$this->SwitchBooleanScript.="$('#".$textVar."').change(function() {";
			$this->SwitchBooleanScript.="\n";
			$this->SwitchBooleanScript.="$('#".$textVar."').ips".$textVar."($('#".$textVar."'));";
			$this->SwitchBooleanScript.="\n";
			$this->SwitchBooleanScript.=" 	});";
			$this->SwitchBooleanScript.="\n";
			return $this->SwitchBooleanScript;
		}
	}
	// Schreibt den Java-Script fr Switch um den Zustand des Schalters zusetzen der Variable
	public function toIpsSwitchFunktion($Modul) {
		$Einheit =	$this->getEinheit();
		$Einheit1 =	$this->getEinheit1();
		if($Modul == 'FS20'){
			$textVar = $this->getName().$this->getID();
			$textVar = Utility::umlaute_ersetzen(utf8_encode($textVar));
			$ValueT ="'"."FS20_SwitchMode"."'";
			$ValueID = "'".$this->getParent()."'";
			$this->IpsSwitchScript.="state = $(homesite).val();";
			$this->IpsSwitchScript.="\n";
			$this->IpsSwitchScript.="var togs = state.toString()== 'on' ? true:false;";
			$this->IpsSwitchScript.="\n";
			$this->IpsSwitchScript.="if(togs){";
			$this->IpsSwitchScript.="\n";
			$this->IpsSwitchScript.="homesite."."ipsswitch"."('2.0','0',".$ValueT.",".$ValueID.","."true,"."'#".$textVar."'".","."'".$Einheit."',"."'".$Einheit1."');";
			$this->IpsSwitchScript.="\n";
			$this->IpsSwitchScript.="}else{";
			$this->IpsSwitchScript.="\n";
			$this->IpsSwitchScript.="homesite."."ipsswitch"."('2.0','0',".$ValueT.",".$ValueID.","."false,"."'#".$textVar."'".","."'".$Einheit."',"."'".$Einheit1."');";
			$this->IpsSwitchScript.="\n";
			$this->IpsSwitchScript.="}";
			$this->IpsSwitchScript.="\n";
		}elseif($Modul == 'HomeMatic Device'){
			$textVar = $this->getName().$this->getID();
			$StatusVar = 'STATE';
			$textVar = Utility::umlaute_ersetzen(utf8_encode($textVar));
			$ValueT ="'"."HM_WriteValueBoolean"."'";
			$ValueID = "'".$this->getParent()."'";
			$this->IpsSwitchScript.="state = $(homesite).val();";
			$this->IpsSwitchScript.="\n";
			$this->IpsSwitchScript.="var togs = state.toString()== 'on' ? true:false;";
			$this->IpsSwitchScript.="\n";
			$this->IpsSwitchScript.="if(togs){";
			$this->IpsSwitchScript.="\n";
			$this->IpsSwitchScript.="homesite."."homematicswitch"."('2.0','0',".$ValueT.",".$ValueID.","."'".$StatusVar."'".","."true,"."'#".$textVar."'".","."'".$Einheit."',"."'".$Einheit1."');";
			$this->IpsSwitchScript.="\n";
			$this->IpsSwitchScript.="}else{";
			$this->IpsSwitchScript.="\n";
			$this->IpsSwitchScript.="homesite."."homematicswitch"."('2.0','0',".$ValueT.",".$ValueID.","."'".$StatusVar."'".","."false,"."'#".$textVar."'".","."'".$Einheit."',"."'".$Einheit1."');";
			$this->IpsSwitchScript.="\n";
			$this->IpsSwitchScript.="}";
			$this->IpsSwitchScript.="\n";
		}
		return $this->IpsSwitchScript;
	}
	// Schreibt den Java-Script fr den Aufruf des Switches der Variable
	public function toIpsSwitchAufruf($Modul,$InstanzName) {
		$textVar = $this->getName().$this->getID();
		$textVar = Utility::umlaute_ersetzen(utf8_encode($textVar));
		$String = $this->getProfileName();
		if($Modul == 'FS20' && stristr($String, 'Switch')){
			$this->IpsSwitchAufruf.="$('#".$textVar."').change(function() {";
			$this->IpsSwitchAufruf.="\n";
			$this->IpsSwitchAufruf.="$('#".$textVar."').ips".$InstanzName."($('#".$textVar."'));";
			$this->IpsSwitchAufruf.="\n";
			$this->IpsSwitchAufruf.=" 	});";
			$this->IpsSwitchAufruf.="\n";
		}elseif($Modul == 'HomeMatic Device' && stristr($String, 'Switch')){
			$this->IpsSwitchAufruf.="$('#".$textVar."').change(function() {";
			$this->IpsSwitchAufruf.="\n";
			$this->IpsSwitchAufruf.="$('#".$textVar."').ips".$InstanzName."($('#".$textVar."'));";
			$this->IpsSwitchAufruf.="\n";
			$this->IpsSwitchAufruf.=" 	});";
			$this->IpsSwitchAufruf.="\n";
		}elseif(empty($Modul) && stristr($String, 'Switch')){
			$this->IpsSwitchAufruf.="$('#".$textVar."').change(function() {";
			$this->IpsSwitchAufruf.="\n";
			$this->IpsSwitchAufruf.="$('#".$textVar."').ips".$textVar."($('#".$textVar."'));";
			$this->IpsSwitchAufruf.="\n";
			$this->IpsSwitchAufruf.=" 	});";
			$this->IpsSwitchAufruf.="\n";
		}
		return $this->IpsSwitchAufruf;
	}
	// Schreibt den Java-Script fr die virtuellen Schaltern der Variable
	public function toIpsSwitchBoolean(){
		$Einheit =	$this->getEinheit();
		$Einheit1 =	$this->getEinheit1();
		$textVar = $this->getName().$this->getID();
		$textVar = Utility::umlaute_ersetzen(utf8_encode($textVar));
		$ValueT ="'"."SetValueBoolean"."'";
		$ValueID = "'".$this->getID()."'";
		$this->IpsSwitchBooleanScript.="(function($) {";
		$this->IpsSwitchBooleanScript.="\n";
		$this->IpsSwitchBooleanScript.="$.fn.ips".$textVar."= function(homesite) {";
		$this->IpsSwitchBooleanScript.="\n";
		$this->IpsSwitchBooleanScript.="state = $(homesite).val();";
		$this->IpsSwitchBooleanScript.="\n";
		$this->IpsSwitchBooleanScript.="var togs = state.toString()== 'on' ? true:false;";
		$this->IpsSwitchBooleanScript.="\n";
		$this->IpsSwitchBooleanScript.="if(togs){";
		$this->IpsSwitchBooleanScript.="\n";
		$this->IpsSwitchBooleanScript.="homesite."."ipsswitch"."('2.0','0',".$ValueT.",".$ValueID.","."true,"."'#".$textVar."'".","."'".$Einheit."',"."'".$Einheit1."');";
		$this->IpsSwitchBooleanScript.="\n";
		$this->IpsSwitchBooleanScript.="}else{";
		$this->IpsSwitchBooleanScript.="\n";
		$this->IpsSwitchBooleanScript.="homesite."."ipsswitch"."('2.0','0',".$ValueT.",".$ValueID.","."false,"."'#".$textVar."'".","."'".$Einheit."',"."'".$Einheit1."');";
		$this->IpsSwitchBooleanScript.="\n";
		$this->IpsSwitchBooleanScript.="}";
		$this->IpsSwitchBooleanScript.="\n";
		$this->IpsSwitchBooleanScript.="}";
		$this->IpsSwitchBooleanScript.="\n";
		$this->IpsSwitchBooleanScript.="})(jQuery);";
		$this->IpsSwitchBooleanScript.="\n";
		return $this->IpsSwitchBooleanScript;
	}
	// Schreibt den Java-Script fr die Graphen der Variable
	public function toGraphAufruf($Instanzname){
		if($this->getStatus()){
			$textVar = $this->getName().$this->getID()."Button";
			$textVar = Utility::umlaute_ersetzen(utf8_encode($textVar));
			$this->GraphAufruf.="$('#".$textVar."').live('click', function() {";
			$this->GraphAufruf.="\n";
			$this->GraphAufruf.="$.mobile.changePage('graph.html', { transition: 'pop'});";
			$this->GraphAufruf.="\n";
			$this->GraphAufruf.="sessionStorage.datei = sessionStorage.Server +'/graph.php?ID=".$this->getID()."';";
			$this->GraphAufruf.="\n";
			$this->GraphAufruf.="sessionStorage.ueberschrift ='".$Instanzname."-".$this->getName()."';";
			$this->GraphAufruf.="\n";
			$this->GraphAufruf.="});";
			$this->GraphAufruf.="\n";
		}
		return $this->GraphAufruf;
	}
	// Schreibt den Java-Script fr Slider der Variable
	public function toSliderAufruf(){
		$String = $this->getProfileName();
		if(stristr($String, 'FHT.Temperatur') && $this->getValueType()==2) {
			$textVar = $this->getName().$this->getID();
			$textVar = Utility::umlaute_ersetzen(utf8_encode($textVar));
			$this->SliderAufrufScript.="$('#".$textVar."').live('change', function(){";
			$this->SliderAufrufScript.="\n";
			$this->SliderAufrufScript.="$('#".$textVar."').ipsSet".$textVar."($('#".$textVar."'));";
			$this->SliderAufrufScript.="\n";
			$this->SliderAufrufScript.="});";
			$this->SliderAufrufScript.="\n";
	 	return $this->SliderAufrufScript;
		}
	}

}
?>
